#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Globalization;
using System.Text;
using System.Threading;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Resources;
using System.Drawing.Printing;
using System.Text.RegularExpressions;

using System.IO;
using System.Runtime.Serialization;
using System.Runtime.InteropServices;
using System.Runtime.Serialization.Formatters;
using System.Runtime.Serialization.Formatters.Soap;

using Microsoft.Vsa;
using Microsoft.VisualBasic;
using Syncfusion.Runtime.InteropServices.WinAPI;
using Syncfusion.Runtime.Serialization;
using Syncfusion.Scripting;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.SVG.IO;
using Syncfusion.Windows.Forms.Diagram.Controls;

namespace Syncfusion.Windows.Forms.Diagram.Samples.DiagramTool
{
	/// <summary>
	/// MainForm for the Essential Diagram Builder.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		#region Fields

		private Syncfusion.Windows.Forms.Tools.DockingManager dockingManager;
		private Syncfusion.Windows.Forms.Tools.TabbedMDIManager tabbedMDIManager;
		private System.Windows.Forms.OpenFileDialog openPaletteDialog;
		private System.Windows.Forms.OpenFileDialog openDiagramDialog;
		private System.Windows.Forms.SaveFileDialog saveDiagramDialog;
		private System.Windows.Forms.OpenFileDialog openImageDialog;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupBar symbolPaletteGroupBar;
		private Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager mainFrameBarManager;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar mainMenuBar;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem7;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem biFileNew;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem biFileOpen;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem biFileSave;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem biFileSaveAs;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem biAddPalette;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem biFileExit;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem biTabbedMDI;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditCut;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditCopy;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditPaste;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditUndo;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditRedo;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAbout;
		private Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor propertyEditor;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar standardToolbar;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem biFilePrint;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem biPageSetup;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemViewSymbolPalette;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemViewProperties;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditSelectAll;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItemEdit;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItemFile;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItemView;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItemWindow;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItemHelp;
		private System.Windows.Forms.ImageList smallImageList;
		private ResourceManager resStringMgr;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem biPrintPreview;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPanZoom;
		private Syncfusion.Windows.Forms.Diagram.Controls.OverviewControl overviewControl1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemHeaderFooter;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPageBorders;
		private System.ComponentModel.IContainer components;

		#endregion

		#region Constructors

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Initialize tabbed MDI manager
			//
			tabbedMDIManager = new Syncfusion.Windows.Forms.Tools.TabbedMDIManager();
			tabbedMDIManager.AttachToMdiContainer(this);

			// Create resource manager for strings
			this.resStringMgr = new ResourceManager("Syncfusion.Windows.Forms.Diagram.Samples.DiagramTool.Strings", typeof(MainForm).Assembly);

			// Wire up OnIdle processing
			Application.Idle += new System.EventHandler(this.OnIdle);					
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.dockingManager = new Syncfusion.Windows.Forms.Tools.DockingManager(this.components);
            this.propertyEditor = new Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor();
            this.symbolPaletteGroupBar = new Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupBar();
            this.overviewControl1 = new Syncfusion.Windows.Forms.Diagram.Controls.OverviewControl();
            this.openPaletteDialog = new System.Windows.Forms.OpenFileDialog();
            this.openDiagramDialog = new System.Windows.Forms.OpenFileDialog();
            this.saveDiagramDialog = new System.Windows.Forms.SaveFileDialog();
            this.smallImageList = new System.Windows.Forms.ImageList(this.components);
            this.openImageDialog = new System.Windows.Forms.OpenFileDialog();
            this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.mainFrameBarManager = new Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager(this);
            this.mainMenuBar = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "MainMenu");
            this.parentBarItemFile = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
            this.biFileNew = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.biFileOpen = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.biFileSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.biFileSaveAs = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.biAddPalette = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.biPageSetup = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.biPrintPreview = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.biFilePrint = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.biFileExit = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.parentBarItemEdit = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
            this.barItemEditUndo = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemEditRedo = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemEditSelectAll = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemEditCut = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemEditCopy = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemEditPaste = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.parentBarItemView = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
            this.barItemViewSymbolPalette = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemViewProperties = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemPanZoom = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemHeaderFooter = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemPageBorders = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.parentBarItemWindow = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
            this.biTabbedMDI = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.parentBarItemHelp = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
            this.barItemAbout = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.standardToolbar = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "Standard");
            this.parentBarItem7 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
            ((System.ComponentModel.ISupportInitialize)(this.dockingManager)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.symbolPaletteGroupBar)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).BeginInit();
            this.SuspendLayout();
            // 
            // dockingManager
            // 
            this.dockingManager.DockLayoutStream = ((System.IO.MemoryStream)(resources.GetObject("dockingManager.DockLayoutStream")));
            this.dockingManager.HostControl = this;
            this.dockingManager.ThemesEnabled = true;
            this.dockingManager.DockVisibilityChanged += new Syncfusion.Windows.Forms.Tools.DockVisibilityChangedEventHandler(this.dockingManager_DockVisibilityChanged);
            this.dockingManager.NewDockStateEndLoad += new System.EventHandler(this.dockingManager_NewDockStateEndLoad);
            this.dockingManager.SetDockLabel(this.propertyEditor, "Properties");
            this.dockingManager.SetDockLabel(this.symbolPaletteGroupBar, "Symbol Palettes");
            this.dockingManager.SetDockLabel(this.overviewControl1, "Pan & Zoom");
            this.dockingManager.SetHiddenOnLoad(this.overviewControl1, true);
            // 
            // propertyEditor
            // 
            this.propertyEditor.Diagram = null;
            this.dockingManager.SetEnableDocking(this.propertyEditor, true);
            this.propertyEditor.Location = new System.Drawing.Point(1, 21);
            this.propertyEditor.Name = "propertyEditor";
            this.propertyEditor.Size = new System.Drawing.Size(201, 232);
            this.propertyEditor.TabIndex = 11;
            // 
            // symbolPaletteGroupBar
            // 
            this.symbolPaletteGroupBar.AllowDrop = true;
            this.symbolPaletteGroupBar.EditMode = false;
            this.dockingManager.SetEnableDocking(this.symbolPaletteGroupBar, true);
            this.symbolPaletteGroupBar.Location = new System.Drawing.Point(1, 21);
            this.symbolPaletteGroupBar.Name = "symbolPaletteGroupBar";
            this.symbolPaletteGroupBar.Size = new System.Drawing.Size(139, 493);
            this.symbolPaletteGroupBar.TabIndex = 9;
            this.symbolPaletteGroupBar.Text = "paletteGroupBar1";
            // 
            // overviewControl1
            // 
            this.overviewControl1.BackColor = System.Drawing.SystemColors.AppWorkspace;
            this.dockingManager.SetEnableDocking(this.overviewControl1, true);
            this.overviewControl1.ForeColor = System.Drawing.Color.Red;
            this.overviewControl1.Location = new System.Drawing.Point(1, 21);
            this.overviewControl1.Name = "overviewControl1";
            this.overviewControl1.Size = new System.Drawing.Size(201, 235);
            this.overviewControl1.TabIndex = 11;
            // 
            // openPaletteDialog
            // 
            this.openPaletteDialog.DefaultExt = "edp";
            this.openPaletteDialog.Filter = "Essential Diagram Palettes|*.edp|Visio Stencils|*.vss; *.vsx|Visio Drawings(Shape" +
                "s only)|*.vsd; *.vdx|All files|*.*";
            this.openPaletteDialog.Title = "Add Palette";
            // 
            // openDiagramDialog
            // 
            this.openDiagramDialog.Filter = "Diagram Files|*.edd|All files|*.*";
            this.openDiagramDialog.Title = "Open Diagram";
            // 
            // saveDiagramDialog
            // 
            this.saveDiagramDialog.FileName = "doc1";
            this.saveDiagramDialog.Filter = "Diagram files|*.edd|EMF file|*.emf|GIF file|*.gif|PNG file|*.png|BMP file|*.bmp|J" +
                "PEG file|*.jpeg,*.jpg|TIFF file|*.tiff|SVG file|*.svg|All files|*.*";
            // 
            // smallImageList
            // 
            this.smallImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("smallImageList.ImageStream")));
            this.smallImageList.TransparentColor = System.Drawing.Color.Fuchsia;
            this.smallImageList.Images.SetKeyName(0, "");
            this.smallImageList.Images.SetKeyName(1, "");
            this.smallImageList.Images.SetKeyName(2, "");
            this.smallImageList.Images.SetKeyName(3, "");
            this.smallImageList.Images.SetKeyName(4, "");
            this.smallImageList.Images.SetKeyName(5, "");
            this.smallImageList.Images.SetKeyName(6, "");
            this.smallImageList.Images.SetKeyName(7, "");
            this.smallImageList.Images.SetKeyName(8, "");
            this.smallImageList.Images.SetKeyName(9, "");
            this.smallImageList.Images.SetKeyName(10, "");
            this.smallImageList.Images.SetKeyName(11, "");
            // 
            // openImageDialog
            // 
            this.openImageDialog.Filter = "Windows Bitmaps|*.bmp|Enhanced Metafiles|*.emf|All files|*.*";
            this.openImageDialog.Title = "Insert Image";
            // 
            // barItem1
            // 
            this.barItem1.CategoryIndex = 3;
            this.barItem1.ID = "Pan";
            this.barItem1.ImageIndex = 10;
            this.barItem1.Tag = "PanTool";
            this.barItem1.Text = "Pan";
            this.barItem1.Tooltip = "Pan";
            // 
            // mainFrameBarManager
            // 
            this.mainFrameBarManager.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("mainFrameBarManager.BarPositionInfo")));
            this.mainFrameBarManager.Bars.Add(this.mainMenuBar);
            this.mainFrameBarManager.Bars.Add(this.standardToolbar);
            this.mainFrameBarManager.Categories.Add("Popups");
            this.mainFrameBarManager.Categories.Add("File");
            this.mainFrameBarManager.Categories.Add("Window");
            this.mainFrameBarManager.Categories.Add("Edit");
            this.mainFrameBarManager.Categories.Add("Help");
            this.mainFrameBarManager.Categories.Add("View");
            this.mainFrameBarManager.Categories.Add("Dialogs");
            this.mainFrameBarManager.CurrentBaseFormType = "System.Windows.Forms.Form";
            this.mainFrameBarManager.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.mainFrameBarManager.Form = this;
            this.mainFrameBarManager.ImageList = null;
            this.mainFrameBarManager.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.biFileNew,
            this.biFileOpen,
            this.biFileSave,
            this.biFileSaveAs,
            this.parentBarItemFile,
            this.biPageSetup,
            this.biPrintPreview,
            this.biFilePrint,
            this.biAddPalette,
            this.parentBarItemEdit,
            this.biFileExit,
            this.parentBarItemView,
            this.parentBarItemWindow,
            this.parentBarItemHelp,
            this.biTabbedMDI,
            this.barItemEditCut,
            this.barItemEditCopy,
            this.barItemEditPaste,
            this.barItemEditUndo,
            this.barItemEditRedo,
            this.barItemAbout,
            this.barItemViewSymbolPalette,
            this.barItemViewProperties,
            this.barItemEditSelectAll,
            this.barItemPanZoom,
            this.barItemHeaderFooter,
            this.barItemPageBorders});
            this.mainFrameBarManager.LargeImageList = null;
            this.mainFrameBarManager.ResetCustomization = false;
            this.mainFrameBarManager.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
            // 
            // mainMenuBar
            // 
            this.mainMenuBar.BarName = "MainMenu";
            this.mainMenuBar.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)(((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.IsMainMenu)
                        | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.RotateWhenVertical)
                        | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible)
                        | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder)));
            this.mainMenuBar.Caption = "MainMenu";
            this.mainMenuBar.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.parentBarItemFile,
            this.parentBarItemEdit,
            this.parentBarItemView,
            this.parentBarItemWindow,
            this.parentBarItemHelp});
            this.mainMenuBar.Manager = this.mainFrameBarManager;
            // 
            // parentBarItemFile
            // 
            this.parentBarItemFile.CategoryIndex = 0;
            this.parentBarItemFile.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.parentBarItemFile.ID = "File";
            this.parentBarItemFile.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.biFileNew,
            this.biFileOpen,
            this.biFileSave,
            this.biFileSaveAs,
            this.biAddPalette,
            this.biPageSetup,
            this.biPrintPreview,
            this.biFilePrint,
            this.biFileExit});
            this.parentBarItemFile.SeparatorIndices.AddRange(new int[] {
            4,
            5,
            9});
            this.parentBarItemFile.Text = "&File";
            // 
            // biFileNew
            // 
            this.biFileNew.CategoryIndex = 1;
            this.biFileNew.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.biFileNew.ID = "New";
            this.biFileNew.ImageIndex = 0;
            this.biFileNew.ImageList = this.smallImageList;
            this.biFileNew.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
            this.biFileNew.Text = "&New";
            this.biFileNew.Click += new System.EventHandler(this.biFileNew_Click);
            // 
            // biFileOpen
            // 
            this.biFileOpen.CategoryIndex = 1;
            this.biFileOpen.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.biFileOpen.ID = "Open";
            this.biFileOpen.ImageIndex = 1;
            this.biFileOpen.ImageList = this.smallImageList;
            this.biFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
            this.biFileOpen.Text = "&Open";
            this.biFileOpen.Click += new System.EventHandler(this.biFileOpen_Click);
            // 
            // biFileSave
            // 
            this.biFileSave.CategoryIndex = 1;
            this.biFileSave.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.biFileSave.ID = "Save";
            this.biFileSave.ImageIndex = 2;
            this.biFileSave.ImageList = this.smallImageList;
            this.biFileSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
            this.biFileSave.Text = "&Save";
            this.biFileSave.Click += new System.EventHandler(this.biFileSave_Click);
            // 
            // biFileSaveAs
            // 
            this.biFileSaveAs.CategoryIndex = 1;
            this.biFileSaveAs.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.biFileSaveAs.ID = "Save As...";
            this.biFileSaveAs.Text = "Save As...";
            this.biFileSaveAs.Click += new System.EventHandler(this.biFileSaveAs_Click);
            // 
            // biAddPalette
            // 
            this.biAddPalette.CategoryIndex = 1;
            this.biAddPalette.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.biAddPalette.ID = "Add Palette";
            this.biAddPalette.Text = "Add Palette";
            this.biAddPalette.Click += new System.EventHandler(this.biFileAddPalette_Click);
            // 
            // biPageSetup
            // 
            this.biPageSetup.CategoryIndex = 1;
            this.biPageSetup.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.biPageSetup.ID = "Page Setup";
            this.biPageSetup.ImageIndex = 8;
            this.biPageSetup.ImageList = this.smallImageList;
            this.biPageSetup.Text = "Page Setup";
            this.biPageSetup.Click += new System.EventHandler(this.biPageSetup_Click);
            // 
            // biPrintPreview
            // 
            this.biPrintPreview.CategoryIndex = 1;
            this.biPrintPreview.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.biPrintPreview.ID = "Print Preview";
            this.biPrintPreview.ImageIndex = 11;
            this.biPrintPreview.ImageList = this.smallImageList;
            this.biPrintPreview.Text = "Print Preview";
            this.biPrintPreview.Tooltip = "Print Preview";
            this.biPrintPreview.Click += new System.EventHandler(this.biPrintPreview_Click);
            // 
            // biFilePrint
            // 
            this.biFilePrint.CategoryIndex = 1;
            this.biFilePrint.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.biFilePrint.ID = "Print";
            this.biFilePrint.ImageIndex = 6;
            this.biFilePrint.ImageList = this.smallImageList;
            this.biFilePrint.Text = "Print";
            this.biFilePrint.Click += new System.EventHandler(this.biFilePrint_Click);
            // 
            // biFileExit
            // 
            this.biFileExit.CategoryIndex = 1;
            this.biFileExit.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.biFileExit.ID = "Exit";
            this.biFileExit.Text = "Exit";
            this.biFileExit.Click += new System.EventHandler(this.biFileExit_Click);
            // 
            // parentBarItemEdit
            // 
            this.parentBarItemEdit.CategoryIndex = 0;
            this.parentBarItemEdit.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.parentBarItemEdit.ID = "Edit";
            this.parentBarItemEdit.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.barItemEditUndo,
            this.barItemEditRedo,
            this.barItemEditSelectAll,
            this.barItemEditCut,
            this.barItemEditCopy,
            this.barItemEditPaste});
            this.parentBarItemEdit.SeparatorIndices.AddRange(new int[] {
            2,
            3});
            this.parentBarItemEdit.Text = "&Edit";
            // 
            // barItemEditUndo
            // 
            this.barItemEditUndo.CategoryIndex = 3;
            this.barItemEditUndo.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemEditUndo.ID = "Undo";
            this.barItemEditUndo.ImageIndex = 9;
            this.barItemEditUndo.ImageList = this.smallImageList;
            this.barItemEditUndo.Shortcut = System.Windows.Forms.Shortcut.CtrlZ;
            this.barItemEditUndo.Text = "&Undo";
            this.barItemEditUndo.Click += new System.EventHandler(this.barItemEditUndo_Click);
            // 
            // barItemEditRedo
            // 
            this.barItemEditRedo.CategoryIndex = 3;
            this.barItemEditRedo.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemEditRedo.ID = "EditRedo";
            this.barItemEditRedo.ImageIndex = 10;
            this.barItemEditRedo.ImageList = this.smallImageList;
            this.barItemEditRedo.Shortcut = System.Windows.Forms.Shortcut.CtrlY;
            this.barItemEditRedo.Text = "&Redo";
            this.barItemEditRedo.Click += new System.EventHandler(this.barItemEditRedo_Click);
            // 
            // barItemEditSelectAll
            // 
            this.barItemEditSelectAll.CategoryIndex = 3;
            this.barItemEditSelectAll.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemEditSelectAll.ID = "&Select All";
            this.barItemEditSelectAll.Shortcut = System.Windows.Forms.Shortcut.CtrlA;
            this.barItemEditSelectAll.Text = "Select &All";
            this.barItemEditSelectAll.Click += new System.EventHandler(this.barItemEditSelectAll_Click);
            // 
            // barItemEditCut
            // 
            this.barItemEditCut.CategoryIndex = 3;
            this.barItemEditCut.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemEditCut.ID = "Cut";
            this.barItemEditCut.ImageIndex = 3;
            this.barItemEditCut.ImageList = this.smallImageList;
            this.barItemEditCut.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
            this.barItemEditCut.Text = "C&ut";
            this.barItemEditCut.Click += new System.EventHandler(this.barItemEditCut_Click);
            // 
            // barItemEditCopy
            // 
            this.barItemEditCopy.CategoryIndex = 3;
            this.barItemEditCopy.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemEditCopy.ID = "Copy";
            this.barItemEditCopy.ImageIndex = 4;
            this.barItemEditCopy.ImageList = this.smallImageList;
            this.barItemEditCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
            this.barItemEditCopy.Text = "&Copy";
            this.barItemEditCopy.Click += new System.EventHandler(this.barItemEditCopy_Click);
            // 
            // barItemEditPaste
            // 
            this.barItemEditPaste.CategoryIndex = 3;
            this.barItemEditPaste.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemEditPaste.ID = "Paste";
            this.barItemEditPaste.ImageIndex = 5;
            this.barItemEditPaste.ImageList = this.smallImageList;
            this.barItemEditPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
            this.barItemEditPaste.Text = "&Paste";
            this.barItemEditPaste.Click += new System.EventHandler(this.barItemEditPaste_Click);
            // 
            // parentBarItemView
            // 
            this.parentBarItemView.CategoryIndex = 0;
            this.parentBarItemView.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.parentBarItemView.ID = "View";
            this.parentBarItemView.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.barItemViewSymbolPalette,
            this.barItemViewProperties,
            this.barItemPanZoom,
            this.barItemHeaderFooter,
            this.barItemPageBorders});
            this.parentBarItemView.SeparatorIndices.AddRange(new int[] {
            3});
            this.parentBarItemView.Text = "&View";
            // 
            // barItemViewSymbolPalette
            // 
            this.barItemViewSymbolPalette.CategoryIndex = 5;
            this.barItemViewSymbolPalette.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemViewSymbolPalette.ID = "Symbol Palette";
            this.barItemViewSymbolPalette.Text = "Symbol Palette";
            this.barItemViewSymbolPalette.Click += new System.EventHandler(this.barItemViewSymbolPalette_Click);
            // 
            // barItemViewProperties
            // 
            this.barItemViewProperties.CategoryIndex = 5;
            this.barItemViewProperties.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemViewProperties.ID = "Properties";
            this.barItemViewProperties.Text = "Properties";
            this.barItemViewProperties.Click += new System.EventHandler(this.barItemViewProperties_Click);
            // 
            // barItemPanZoom
            // 
            this.barItemPanZoom.CategoryIndex = 5;
            this.barItemPanZoom.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemPanZoom.ID = "panZoomWindow";
            this.barItemPanZoom.Text = "Pan & Zoom Window";
            this.barItemPanZoom.Tooltip = "Pan & Zoom Window";
            this.barItemPanZoom.Click += new System.EventHandler(this.barItemPanZoom_Click);
            // 
            // barItemHeaderFooter
            // 
            this.barItemHeaderFooter.CategoryIndex = 5;
            this.barItemHeaderFooter.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemHeaderFooter.ID = "Header Footer";
            this.barItemHeaderFooter.Text = "Header Footer";
            this.barItemHeaderFooter.Click += new System.EventHandler(this.barItemHeaderFooter_Click);
            // 
            // barItemPageBorders
            // 
            this.barItemPageBorders.CategoryIndex = 5;
            this.barItemPageBorders.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemPageBorders.ID = "Page Borders";
            this.barItemPageBorders.Text = "Page Borders";
            this.barItemPageBorders.Click += new System.EventHandler(this.barItemPageBorders_Click);
            // 
            // parentBarItemWindow
            // 
            this.parentBarItemWindow.CategoryIndex = 0;
            this.parentBarItemWindow.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.parentBarItemWindow.ID = "Window";
            this.parentBarItemWindow.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.biTabbedMDI});
            this.parentBarItemWindow.Text = "&Window";
            // 
            // biTabbedMDI
            // 
            this.biTabbedMDI.CategoryIndex = 2;
            this.biTabbedMDI.Checked = true;
            this.biTabbedMDI.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.biTabbedMDI.ID = "Tabbed MDI";
            this.biTabbedMDI.Text = "Tabbed MDI";
            this.biTabbedMDI.Click += new System.EventHandler(this.biTabbedMDI_Click);
            // 
            // parentBarItemHelp
            // 
            this.parentBarItemHelp.CategoryIndex = 0;
            this.parentBarItemHelp.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.parentBarItemHelp.ID = "Help";
            this.parentBarItemHelp.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.barItemAbout});
            this.parentBarItemHelp.Text = "&Help";
            // 
            // barItemAbout
            // 
            this.barItemAbout.CategoryIndex = 4;
            this.barItemAbout.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.barItemAbout.ID = "About";
            this.barItemAbout.Text = "About...";
            this.barItemAbout.Click += new System.EventHandler(this.barItemAbout_Click);
            // 
            // standardToolbar
            // 
            this.standardToolbar.BarName = "Standard";
            this.standardToolbar.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.RotateWhenVertical)
                        | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible)
                        | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder)));
            this.standardToolbar.Caption = "Standard";
            this.standardToolbar.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.biFileNew,
            this.biFileOpen,
            this.biFileSave,
            this.biPrintPreview,
            this.biFilePrint});
            this.standardToolbar.Manager = this.mainFrameBarManager;
            // 
            // parentBarItem7
            // 
            this.parentBarItem7.CategoryIndex = 3;
            this.parentBarItem7.ID = "Zoom";
            this.parentBarItem7.ImageIndex = 8;
            this.parentBarItem7.Text = "Zoom";
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(792, 566);
            this.IsMdiContainer = true;
            this.Name = "MainForm";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Diagram Builder";
            this.MdiChildActivate += new System.EventHandler(this.MainForm_MdiChildActivate);
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.MainForm_FormClosing);
            this.Load += new System.EventHandler(this.MainForm_Load);
            ((System.ComponentModel.ISupportInitialize)(this.dockingManager)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.symbolPaletteGroupBar)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		#region MainForm Event Handlers

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			this.barItemViewProperties.Checked = true;
			this.barItemViewSymbolPalette.Checked = true;
			
			//Load Palettes
			string exepath = Application.ExecutablePath.ToLower();
			string symbolpalettepath = exepath.Substring(0, exepath.IndexOf("diagrambuilder")) + "diagrambuilder\\cs\\symbol palettes";
			this.symbolPaletteGroupBar.LoadPalette(symbolpalettepath + "\\Basic Shapes.edp");
			this.symbolPaletteGroupBar.LoadPalette(symbolpalettepath + "\\Electrical Symbols.edp");
			this.symbolPaletteGroupBar.LoadPalette(symbolpalettepath + "\\Flowchart Symbols.edp");

			// New diagram
			DiagramForm docForm = new DiagramForm();
			docForm.MdiParent = this;
			docForm.Closing += new CancelEventHandler(DiagramForm_Closing);
			docForm.Show();
			System.Diagnostics.Trace.WriteLine( "Form.Show()" );

		}

		private void MainForm_MdiChildActivate(object sender, System.EventArgs e)
		{
			DiagramForm diagramForm = this.ActiveMdiChild as DiagramForm;
			if(diagramForm != null)
			{
				this.propertyEditor.Diagram = diagramForm.Diagram;

				// If the OverviewControl is visible then change the OverviewControl.Model and OverviewControl.View 
				// properties to reference the new diagram's Model and View
				if(this.dockingManager.GetDockVisibility(this.overviewControl1) == true)
				{
					this.overviewControl1.Model = diagramForm.Diagram.Model;
					this.overviewControl1.View = diagramForm.Diagram.View;
				}
			}
		}

		#endregion

		#region Properties

		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram ActiveDiagram
		{
			get
			{
				Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram = null;

				if (this.ActiveMdiChild != null)
				{
					DiagramForm diagramForm = this.ActiveMdiChild as DiagramForm;
					if (diagramForm != null)
					{
						diagram = diagramForm.Diagram;
					}
				}

				return diagram;
			}
		}

		private DiagramForm ActiveDiagramForm
		{
			get
			{
				DiagramForm diagramForm = null;

				if (this.ActiveMdiChild != null)
				{
					diagramForm = this.ActiveMdiChild as DiagramForm;
				}

				return diagramForm;
			}
		}

		public PropertyEditor PropertyEditor
		{
			get
			{
				return this.propertyEditor;
			}
		}

		#endregion

		#region File Menu Event Handlers

		private void biFileAddPalette_Click(object sender, System.EventArgs e)
		{
			// Open symbol palette and add it to the symbol palette group bar
			if (openPaletteDialog.ShowDialog(this) == DialogResult.OK)
			{
				SymbolPalette curPalette = null;
				FileStream iStream = null;

				string strFileName = openPaletteDialog.FileName;

				RegexOptions options = RegexOptions.IgnoreCase|RegexOptions.RightToLeft;
				Match match = Regex.Match(strFileName, ".vss|.vsx|.vsd|.vdx", options);

				if ( match.Success )
				{
					VisioStencilConverter converter = new VisioStencilConverter(strFileName, this);
					converter.ShowProgressDialog = true;
					curPalette = converter.Convert();
                    if (curPalette != null)
					symbolPaletteGroupBar.AddPalette(curPalette);
				}
				else
				{
					try
					{
						iStream = new FileStream(strFileName, FileMode.Open, FileAccess.Read);
					}
					catch (Exception ex)
					{
						iStream = null;
						MessageBox.Show(this, ex.Message);
					}

					if (iStream != null)
					{
						SoapFormatter formatter = new SoapFormatter();
						formatter.Binder = Syncfusion.Runtime.Serialization.AppStateSerializer.CustomBinder;
						formatter.AssemblyFormat = FormatterAssemblyStyle.Simple;						
						try
						{
							AppDomain.CurrentDomain.AssemblyResolve += new ResolveEventHandler(DiagramBaseAssembly.AssemblyResolver);
							curPalette = (SymbolPalette) formatter.Deserialize(iStream);
							symbolPaletteGroupBar.AddPalette(curPalette);
						}
						catch (Exception ex)
						{
							MessageBox.Show(this, ex.Message);
						}
						finally
						{
							iStream.Close();
						}
					}
				}
			}
		}

		private void biFileNew_Click(object sender, System.EventArgs e)
		{
			// New diagram
			DiagramForm docForm = new DiagramForm();
			docForm.MdiParent = this;
			docForm.Closing += new CancelEventHandler(DiagramForm_Closing);
			docForm.Show();
		}

		private void biFileOpen_Click(object sender, System.EventArgs e)
		{
			// Open diagram
			if (this.openDiagramDialog.ShowDialog(this) == DialogResult.OK)
			{
				DiagramForm docForm = new DiagramForm();
				docForm.OpenFile(this.openDiagramDialog.FileName);
				docForm.MdiParent = this;
				docForm.Closing += new CancelEventHandler(DiagramForm_Closing);
				docForm.Show();
			}
		}

		private void biFileSave_Click(object sender, System.EventArgs e)
		{
			// Save diagram
			DiagramForm docForm = this.ActiveDiagramForm;
			if (docForm != null)
			{
				if (!docForm.HasFileName)
				{
					if (this.saveDiagramDialog.ShowDialog(this) == DialogResult.OK)
					{
						docForm.SaveAsFile(this.saveDiagramDialog.FileName);
					}
				}
				else
				{
					docForm.SaveFile();
				}
			}
		}

		private void biFileSaveAs_Click(object sender, System.EventArgs e)
		{
			// Save diagram
			DiagramForm docForm = this.ActiveDiagramForm;
			if (docForm != null)
			{
				if (docForm.HasFileName)
				{
					this.saveDiagramDialog.FileName = docForm.FileName;
				}
				if (this.saveDiagramDialog.ShowDialog(this) == DialogResult.OK)
				{
					string strFileName = this.saveDiagramDialog.FileName;
					// search for file extension
					RegexOptions options = RegexOptions.IgnoreCase;
					Match match = Regex.Match(strFileName, "([^.]*)$", options);
					if ( match.Success )
					{
						Image imgDiagram = null;

						switch ( match.Value )
						{
							case "svg":
								ToSvg tosvg = new ToSvg();
								// Get Diagram Nodes Bounding Rectangle.
								RectangleF rectBounding = this.ActiveDiagramForm.Diagram.Model.GetBoundingRect();
								Graphics gfx = tosvg.GetRealGraphics(new Size(( int )rectBounding.Width, ( int )rectBounding.Height));
								this.ActiveDiagram.ExportDiagramToGraphics(gfx);
								tosvg.Save(strFileName);
								
								break;
							case "emf":
								//Save Diagram to created image.
								imgDiagram = this.ActiveDiagram.ExportDiagramAsImage( false );
								
								// Save image as metafile.
								imgDiagram.Save( strFileName, ImageFormat.Emf );
								break;
							case "png":
								//Save Diagram to created image.
								imgDiagram = this.ActiveDiagram.ExportDiagramAsImage( false );
								
								// Save image as metafile.
								imgDiagram.Save( strFileName, ImageFormat.Png );
								break;
							case "jpg":
							case "jpeg":
								//Save Diagram to created image.
								imgDiagram = this.ActiveDiagram.ExportDiagramAsImage( false );
								
								// Save image as metafile.
								imgDiagram.Save( strFileName, ImageFormat.Jpeg );
								break;
							case "tiff":
								//Save Diagram to created image.
								imgDiagram = this.ActiveDiagram.ExportDiagramAsImage( false );
								
								// Save image as metafile.
								imgDiagram.Save( strFileName, ImageFormat.Tiff );
								break;
							case "gif":
								//Save Diagram to created image.
								imgDiagram = this.ActiveDiagram.ExportDiagramAsImage( false );
								
								// Save image as metafile.
								imgDiagram.Save( strFileName, ImageFormat.Gif );
								break;
							case "bmp":
								//Save Diagram to created image.
								imgDiagram = this.ActiveDiagram.ExportDiagramAsImage( false );
								
								// Save image as metafile.
								imgDiagram.Save( strFileName, ImageFormat.Bmp );
								break;

							default:
								docForm.SaveAsFile(this.saveDiagramDialog.FileName);
								break;
						}
					}
				}
			}
		}
		
		private void biPrintPreview_Click(object sender, System.EventArgs e)
		{
			this.PrintPreview();			
		}		

		private void biFilePrint_Click(object sender, System.EventArgs e)
		{
			this.Print();
		}

		private void biPageSetup_Click(object sender, System.EventArgs e)
		{
			this.PageSetup();
		}

		private void biFileExit_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}
		

		private void barItemHeaderFooter_Click(object sender, EventArgs e)
		{
			HeaderFooterSetup();
		}

		private void barItemPageBorders_Click(object sender, EventArgs e)
		{
			PageBordersSetup();
		}


		#endregion

		#region Edit Menu Event Handlers

		private void barItemEditCut_Click(object sender, System.EventArgs e)
		{
			if (this.ActiveMdiChild != null)
			{
				DiagramForm diagramForm = this.ActiveMdiChild as DiagramForm;
				if (diagramForm != null)
				{
					diagramForm.Diagram.Controller.Cut();
				}
			}
		}

		private void barItemEditCopy_Click(object sender, System.EventArgs e)
		{
			if (this.ActiveMdiChild != null)
			{
				DiagramForm diagramForm = this.ActiveMdiChild as DiagramForm;
				if (diagramForm != null)
				{
					diagramForm.Diagram.Controller.Copy();
				}
			}
		}

		private void barItemEditPaste_Click(object sender, System.EventArgs e)
		{
			if (this.ActiveMdiChild != null)
			{
				DiagramForm diagramForm = this.ActiveMdiChild as DiagramForm;
				if (diagramForm != null)
				{
					diagramForm.Diagram.Controller.Paste();
				}
			}
		}

		private void barItemEditUndo_Click(object sender, System.EventArgs e)
		{
			if (this.ActiveMdiChild != null)
			{
				DiagramForm diagramForm = this.ActiveMdiChild as DiagramForm;
				if (diagramForm != null)
				{
					diagramForm.Diagram.Controller.UndoCommand();
				}
			}
		}

		private void barItemEditRedo_Click(object sender, System.EventArgs e)
		{
			if (this.ActiveMdiChild != null)
			{
				DiagramForm diagramForm = this.ActiveMdiChild as DiagramForm;
				if (diagramForm != null)
				{
					diagramForm.Diagram.Controller.RedoCommand();
				}
			}
		}

		private void barItemEditSelectAll_Click(object sender, System.EventArgs e)
		{
			if (this.ActiveMdiChild != null)
			{
				DiagramForm diagramForm = this.ActiveMdiChild as DiagramForm;
				if (diagramForm != null)
				{
					diagramForm.Diagram.Controller.SelectAll();
				}
			}
		}

		#endregion

		#region View Menu Event Handlers

		private void barItemViewSymbolPalette_Click(object sender, System.EventArgs e)
		{
			if (this.barItemViewSymbolPalette.Checked)
			{
				this.dockingManager.SetDockVisibility(this.symbolPaletteGroupBar, false);
				this.barItemViewSymbolPalette.Checked = false;
			}
			else
			{
				this.dockingManager.SetDockVisibility(this.symbolPaletteGroupBar, true);
				this.barItemViewSymbolPalette.Checked = true;
			}
		}

		private void barItemViewProperties_Click(object sender, System.EventArgs e)
		{
			if(this.barItemViewProperties.Checked)
			{
				this.dockingManager.SetDockVisibility(this.propertyEditor, false);
				this.barItemViewProperties.Checked = false;
			}
			else
			{
				this.dockingManager.SetDockVisibility(this.propertyEditor, true);
				this.barItemViewProperties.Checked = true;
			}
		}

		private void barItemPanZoom_Click(object sender, System.EventArgs e)
		{
			if(this.barItemPanZoom.Checked == true)
			{
				// Hide the overview control
				this.dockingManager.SetDockVisibility(this.overviewControl1, false);
				this.barItemPanZoom.Checked = false;
			}
			else
			{
				// Initialize the OverviewControl with the active diagram's Model & View and display the control
				if((this.ActiveDiagram != null) && (this.dockingManager.GetDockVisibility(this.overviewControl1) == false))
				{
					this.dockingManager.SetDockVisibility(this.overviewControl1, true);
					this.overviewControl1.Model = this.ActiveDiagram.Model;
					this.overviewControl1.View = this.ActiveDiagram.View;
				}
				this.barItemPanZoom.Checked = true;
			}
		}

		private void HeaderFooterSetup()
		{
			Controls.Diagram activeDiagram =this.ActiveDiagram;
			if ( activeDiagram != null && activeDiagram.Model != null )
			{
				HeaderFooterDialog dlgHF = new HeaderFooterDialog();
				dlgHF.Header = activeDiagram.Model.HeaderFooterData.Header;
				dlgHF.Footer = activeDiagram.Model.HeaderFooterData.Footer;
				dlgHF.MeasurementUnits = activeDiagram.Model.MeasurementUnits;
				if ( dlgHF.ShowDialog() == DialogResult.OK )
				{
					activeDiagram.Model.HeaderFooterData.Header = dlgHF.Header;
					activeDiagram.Model.HeaderFooterData.Footer = dlgHF.Footer;
				}
			}			
		}

		private void PageBordersSetup()
		{
			Controls.Diagram activeDiagram =this.ActiveDiagram;
			if ( activeDiagram != null && activeDiagram.Model != null )
			{
				PageBorderDialog borderDialog = new PageBorderDialog();
				borderDialog.PageBorderStyle = activeDiagram.View.PageBorderStyle;				
				if(borderDialog.ShowDialog() == DialogResult.OK)
				{
					activeDiagram.View.PageBorderStyle = borderDialog.PageBorderStyle;
                    activeDiagram.View.RefreshPageSettings();
                    activeDiagram.View.Update(true);
				}
			}
		}


		#endregion

		#region Window Menu Event Handlers

		private void biTabbedMDI_Click(object sender, System.EventArgs e)
		{
			// Toggle tabbed MDI mode
			Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem = sender as Syncfusion.Windows.Forms.Tools.XPMenus.BarItem;
			if (barItem != null)
			{
				if (barItem.Checked)
				{
					tabbedMDIManager.DetachFromMdiContainer(this, true);
					barItem.Checked = false;
				}
				else
				{
					tabbedMDIManager.AttachToMdiContainer(this);
					barItem.Checked = true;
				}
			}
		}

		#endregion

		#region Help Menu Event Handlers

		private void barItemAbout_Click(object sender, System.EventArgs e)
		{
			About aboutDlg = new About();
			aboutDlg.ShowDialog(this);
		}

		#endregion

		#region Docking

		private void dockingManager_DockVisibilityChanged(object sender, Syncfusion.Windows.Forms.Tools.DockVisibilityChangedEventArgs e)
		{
			if(e.Control == this.propertyEditor)
			{
				this.barItemViewProperties.Checked = this.dockingManager.GetDockVisibility(this.propertyEditor);
			}
			else if(e.Control == this.symbolPaletteGroupBar)
			{
				this.barItemViewSymbolPalette.Checked = this.dockingManager.GetDockVisibility(this.symbolPaletteGroupBar);
			}
			else if(e.Control == this.overviewControl1)
			{
				this.barItemPanZoom.Checked = this.dockingManager.GetDockVisibility(this.overviewControl1);
			}
		}

		#endregion

		#region UI Updating

		private void OnIdle(object sender, System.EventArgs evtArgs)
		{
			Syncfusion.Windows.Forms.Diagram.Controls.Diagram activeDiagram = this.ActiveDiagram;

			string editUndoText = this.resStringMgr.GetString("EditUndoText");
			string editRedoText = this.resStringMgr.GetString("EditRedoText");

			if (activeDiagram != null)
			{
				this.biFileSave.Enabled = true;
				this.biFileSaveAs.Enabled = true;
				this.barItemEditCopy.Enabled = activeDiagram.CanCopy;
				this.barItemEditCut.Enabled = activeDiagram.CanCut;
				this.barItemEditPaste.Enabled = activeDiagram.CanPaste;
				this.barItemEditUndo.Enabled = activeDiagram.Controller.CanUndo;
				this.barItemEditRedo.Enabled = activeDiagram.Controller.CanRedo;
				this.barItemEditSelectAll.Enabled = true;
				this.biFilePrint.Enabled = true;
				this.biPageSetup.Enabled = true;

				string[] strDescriptions;
				int nDescWanted = 1;
				int nDescReturned = activeDiagram.Controller.GetUndoDescriptions( nDescWanted , out strDescriptions );

				if( nDescReturned == nDescWanted )
					editUndoText = editUndoText + " " + strDescriptions[ 0 ];

				// clear strDecsriptions.
				strDescriptions = null;
				nDescReturned = activeDiagram.Controller.GetRedoDescriptions( nDescWanted , out strDescriptions ) ;
				if( nDescReturned == nDescWanted )
					editRedoText = editRedoText + " " + strDescriptions[ 0 ];
			}
			else
			{
				this.biFileSave.Enabled = false;
				this.biFileSaveAs.Enabled = false;
				this.barItemEditCopy.Enabled = false;
				this.barItemEditCut.Enabled = false;
				this.barItemEditPaste.Enabled = false;
				this.barItemEditUndo.Enabled = false;
				this.barItemEditRedo.Enabled = false;
				this.barItemEditSelectAll.Enabled = false;
				this.biFilePrint.Enabled = false;
				this.biPageSetup.Enabled = false;
			}

			this.barItemEditUndo.Text = editUndoText;
			this.barItemEditRedo.Text = editRedoText;
		}

		#endregion

		#region Printing

		private void PageSetup()
		{
			Syncfusion.Windows.Forms.Diagram.Controls.Diagram activeDiagram = this.ActiveDiagram;

			if (activeDiagram != null && activeDiagram.Model != null)
			{
				Syncfusion.Windows.Forms.Diagram.PrintSetupDialog dlgPrintSetup = new PrintSetupDialog();

				// Made to make values more user friendly 
				dlgPrintSetup.PageSettings = activeDiagram.View.PageSettings;
				dlgPrintSetup.PrintZoom = activeDiagram.View.PrintZoom;
				
				if ( dlgPrintSetup.ShowDialog() == DialogResult.OK )
				{
					activeDiagram.View.PageSettings = dlgPrintSetup.PageSettings;
					activeDiagram.View.PrintZoom = dlgPrintSetup.PrintZoom;
					activeDiagram.View.RefreshPageSettings();
					activeDiagram.View.Update(true);
				}
			}			
		}

		private void Print()
		{
//			TextNode txtnode = new TextNode( "Hello World" );
//			txtnode.SizeToText( new SizeF( 500,50 ) );

//			InsertNodesCmd inscmd = new InsertNodesCmd();
//			inscmd.Location = new PointF( 50,50 );
//			inscmd.Nodes.Add( txtnode );
//			this.ActiveDiagram.Controller.ExecuteCommand( inscmd );

//			GroupCmd grpcmd = new GroupCmd();
//			grpcmd.Nodes.Add( txtnode );
//			this.ActiveDiagram.Controller.ExecuteCommand( grpcmd );

			Syncfusion.Windows.Forms.Diagram.Controls.Diagram activeDiagram = this.ActiveDiagram;
			if (activeDiagram != null)
			{
				System.Drawing.Printing.PrintDocument printDoc = activeDiagram.CreatePrintDocument();
				PrintDialog printDlg = new PrintDialog();
				printDlg.Document = printDoc;
	
				printDlg.AllowSomePages = true;
				
				if (printDlg.ShowDialog(this) == DialogResult.OK)
				{
					printDoc.PrinterSettings = printDlg.PrinterSettings;
					printDoc.Print();
				}
			}
		}

		private void PrintPreview()
		{
			Syncfusion.Windows.Forms.Diagram.Controls.Diagram activeDiagram = this.ActiveDiagram;

			if (activeDiagram != null)
			{
				System.Drawing.Printing.PrintDocument printDoc = activeDiagram.CreatePrintDocument();
				PrintPreviewDialog printPreviewDlg = new PrintPreviewDialog();

				printDoc.PrinterSettings.FromPage = 0;
				printDoc.PrinterSettings.ToPage = 0;
				printDoc.PrinterSettings.PrintRange = PrintRange.AllPages;
       
				printPreviewDlg.Document = printDoc;
				printPreviewDlg.ShowDialog(this);
			}
		}				
		
		#endregion

		#region MDI Window Management

		private void DiagramForm_Closing(object sender, CancelEventArgs e)
		{
			DiagramForm docForm = sender as DiagramForm;
			if (docForm != null)
			{
				if (docForm.Diagram.Model.Modified)
				{
					DialogResult res = MessageBox.Show(this, "The diagram has been modified. Save changes?", "Save changes", MessageBoxButtons.YesNoCancel);
					if (res == DialogResult.Yes)
					{
						if (docForm.HasFileName)
						{
							this.saveDiagramDialog.FileName = docForm.FileName;
						}
						if (this.saveDiagramDialog.ShowDialog(this) == DialogResult.OK)
						{
							docForm.SaveAsFile(this.saveDiagramDialog.FileName);
						}
						else
						{
							e.Cancel = true;
						}
					}
					else if (res == DialogResult.Cancel)
					{
						e.Cancel = true;
					}
				}
			}
		}

		#endregion

		#region helper methods
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			// Register scripting engines
			ScriptEngineFactory.RegisterScriptEngine(ScriptLanguages.VisualBasic, typeof(Microsoft.VisualBasic.Vsa.VsaEngine));
			ScriptEngineFactory.RegisterScriptEngine(ScriptLanguages.JScript, typeof(Microsoft.JScript.Vsa.VsaEngine));
                                   
			Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(Syncfusion.Windows.Forms.Diagram.DefaultExceptionHandler.Singleton.OnThreadException);
			Application.Run(new MainForm());
			Application.ThreadException -= new System.Threading.ThreadExceptionEventHandler(Syncfusion.Windows.Forms.Diagram.DefaultExceptionHandler.Singleton.OnThreadException);
		}

        private bool flag = false;
        private void dockingManager_NewDockStateEndLoad(object sender, EventArgs e)
        {
            if (flag == false)
            {
                flag = true;
                AppStateSerializer serializer = AppStateSerializer.GetSingleton();
                this.dockingManager.LoadDockState(serializer);
            }
        }

        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            AppStateSerializer ser = AppStateSerializer.GetSingleton();
            this.dockingManager.SaveDockState(ser);
            //ser.PersistNow();

        }
	}
}
