#Region "Copyright Syncfusion Inc. 2001 - 2005"
'
'  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
'
'  Use of this code is subject to the terms of our license.
'  A copy of the current license can be obtained at any time by e-mailing
'  licensing@syncfusion.com. Any infringement will be prosecuted under
'  applicable laws. 
'
#End Region


Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.IO
Imports System.Reflection
Imports System.Diagnostics
Imports System.Runtime.Serialization.Formatters
Imports System.Runtime.Serialization.Formatters.Binary

Imports Syncfusion.Scripting
Imports Syncfusion.Scripting.Design
Imports Syncfusion.Windows.Forms.Diagram
Imports Syncfusion.Windows.Forms.Tools.XPMenus

Namespace Syncfusion.Windows.Forms.Diagram.Samples.DiagramTool
	''' <summary>
	''' Summary description for DiagramForm.
	''' </summary>
	Public Class DiagramForm : Inherits System.Windows.Forms.Form
		Private WithEvents diagramComponent As Syncfusion.Windows.Forms.Diagram.Controls.Diagram
		Private childFrameBarManager As Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager
		Private smBarItemImages As System.Windows.Forms.ImageList
		Private WithEvents barItemSelect As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemLine As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemRectangle As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemEllipse As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemText As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemPolyline As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemPolygon As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemArc As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemCurve As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemClosedCurve As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemImage As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemGroup As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemUngroup As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemBringToFront As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemSendToBack As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemBringForward As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemSendBackward As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemNudgeUp As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemNudgeDown As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemNudgeLeft As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemNudgeRight As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemRotate As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemRotateLeft As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemRotateRight As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemFlipVertical As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemFlipHorizontal As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private barDrawing As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private barNode As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private barNudge As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private barRotate As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private WithEvents barItemPan As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private bar1 As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private components As System.ComponentModel.IContainer
		Private WithEvents barItemShowGrid As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemSnapToGrid As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemZoom As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents comboBoxBarItemMagnification As Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem
		Private WithEvents barItemOrthogonalLink As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemLink As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private barLinks As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private WithEvents barItemDirectedLink As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemArcLink As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemRichText As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemRoundRect As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemBoldText As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemAlignTextLeft As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemCenterText As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemAlignTextRight As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private comboBoxBarItemFontFamily As Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem
		Private comboBoxBarItemPointSize As Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem
		Private bar2 As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private WithEvents barItemItalicText As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemUnderlineText As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemTextColor As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private bar3 As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private WithEvents barItemLoadScript As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemRunScript As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemEditScript As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemStopScript As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemSuperscript As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemSubscript As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemUpper As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemLower As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
        Private fileName_Renamed As String = Nothing
        Private scriptingMgr As Syncfusion.Scripting.ScriptingManager
        Private WithEvents barItemStrikeoutText As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
        Private m_biSelectedAlignment As BarItem = Nothing

        Private Property CurrentAlignment() As BarItem
            Get
                Return m_biSelectedAlignment
            End Get
            Set(ByVal Value As BarItem)
                If Not m_biSelectedAlignment Is Value Then
                    ' Uncheck current.
                    If Not m_biSelectedAlignment Is Nothing Then
                        m_biSelectedAlignment.Checked = False
                    End If

                    ' Set new value
                    m_biSelectedAlignment = Value

                    ' Check new.
                    If Not m_biSelectedAlignment Is Nothing Then
                        m_biSelectedAlignment.Checked = True
                    End If
                End If
            End Set
        End Property
        Public Sub New()
            '
            ' Required for Windows Form Designer support
            '
            InitializeComponent()

            Me.diagramComponent.Model.Modified = False

            '
            ' Wire up event handlers to canvas
            '
            AddHandler diagramComponent.Controller.SelectionChanged, AddressOf OnSelectionChanged

            ' Setup the Diagram control for scripting capability
            Me.InitializeScriptingManager()

            ' Load up names of fonts that can be selected
            Me.LoadFontSelections()

            ' Tool management
            AddHandler diagramComponent.Controller.ToolActivate, AddressOf Controller_ToolActivate
        End Sub

        ''' <summary>
        ''' Clean up any resources being used.
        ''' </summary>
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not components Is Nothing Then
                    components.Dispose()
                End If
                RemoveHandler diagramComponent.Controller.SelectionChanged, AddressOf OnSelectionChanged

                RemoveHandler scriptingMgr.CompileError, AddressOf scriptingMgr_CompileError
            End If
            MyBase.Dispose(disposing)
        End Sub

        Public ReadOnly Property Diagram() As Syncfusion.Windows.Forms.Diagram.Controls.Diagram
            Get
                Return Me.diagramComponent
            End Get
        End Property

        Public Sub OpenFile(ByVal fileName_Renamed As String)
            Dim iStream As FileStream = New FileStream(fileName_Renamed, FileMode.Open)
            If Not iStream Is Nothing Then
                Try
                    Me.diagramComponent.LoadBinary(iStream)

                    ' Load the DiagramScript object from the serialized stream
                    Dim formatter As BinaryFormatter = New BinaryFormatter
                    formatter.Binder = Syncfusion.Runtime.Serialization.AppStateSerializer.CustomBinder
                    AddHandler System.AppDomain.CurrentDomain.AssemblyResolve, AddressOf DiagramBaseAssembly.AssemblyResolver
                    formatter.AssemblyFormat = FormatterAssemblyStyle.Simple
                    Me.scriptingMgr.ClearScriptSite()
                    Me.scriptingMgr.Script = CType(formatter.Deserialize(iStream), DiagramScript)
                Catch ex As Exception
                    MessageBox.Show("Serialization error - " & ex.Message)
                Finally
                    iStream.Close()
                End Try
                Me.FileName = fileName_Renamed
            End If
        End Sub

        Public Sub SaveFile()
            If (Not Me.HasFileName) Then
                Throw New InvalidOperationException
            End If

            Me.SaveAsFile(Me.fileName_Renamed)
        End Sub

        Public Sub SaveAsFile(ByVal fileName_Renamed As String)
            Dim oStream As FileStream = Nothing

            Try
                oStream = New FileStream(fileName_Renamed, FileMode.Create)
            Catch ex As Exception
                oStream = Nothing ' just to be sure
                MessageBox.Show("Error opening " & fileName_Renamed & " - " & ex.Message)
            End Try

            If Not oStream Is Nothing Then
                Try
                    Me.diagramComponent.SaveBinary(oStream)

                    ' Save the DiagramScript object to the serialization stream along with the diagram document
                    Dim formatter As BinaryFormatter = New BinaryFormatter
                    formatter.Binder = Syncfusion.Runtime.Serialization.AppStateSerializer.CustomBinder
                    formatter.AssemblyFormat = FormatterAssemblyStyle.Simple
                    formatter.Serialize(oStream, CType(Me.scriptingMgr.Script, DiagramScript))

                    Me.FileName = fileName_Renamed
                Catch ex As Exception
                    MessageBox.Show("Serialization error - " & ex.Message)
                Finally
                    oStream.Close()
                End Try
            End If
        End Sub

        Public Property FileName() As String
            Get
                Return Me.fileName_Renamed
            End Get
            Set(ByVal Value As String)
                Me.fileName_Renamed = Value
                Me.Text = System.IO.Path.GetFileNameWithoutExtension(Me.fileName_Renamed)
            End Set
        End Property

        Public ReadOnly Property HasFileName() As Boolean
            Get
                Return (Not Me.fileName_Renamed Is Nothing AndAlso Me.fileName_Renamed.Length > 0)
            End Get
        End Property

        Protected ReadOnly Property PropertyEditor() As Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor
            Get
                If Not Me.MdiParent Is Nothing Then
                    Dim mainForm As mainForm = CType(IIf(TypeOf Me.MdiParent Is mainForm, Me.MdiParent, Nothing), mainForm)
                    If Not mainForm Is Nothing Then
                        Return mainForm.PropertyEditor
                    End If
                End If
                Return Nothing
            End Get
        End Property

#Region "Windows Form Designer generated code"
        ''' <summary>
        ''' Required method for Designer support - do not modify
        ''' the contents of this method with the code editor.
        ''' </summary>
        Private Sub InitializeComponent()
            Me.components = New System.ComponentModel.Container
            Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(DiagramForm))
            Me.diagramComponent = New Syncfusion.Windows.Forms.Diagram.Controls.Diagram
            Me.childFrameBarManager = New Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager(Me.components, Me)
            Me.barDrawing = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.childFrameBarManager, "Drawing")
            Me.barItemSelect = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.smBarItemImages = New System.Windows.Forms.ImageList(Me.components)
            Me.barItemLine = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemPolyline = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemRectangle = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemRoundRect = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemEllipse = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemPolygon = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemCurve = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemClosedCurve = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemArc = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemText = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemRichText = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemImage = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barNode = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.childFrameBarManager, "Node")
            Me.barItemGroup = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemUngroup = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemBringToFront = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemSendToBack = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemBringForward = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemSendBackward = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barNudge = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.childFrameBarManager, "Nudge")
            Me.barItemNudgeUp = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemNudgeDown = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemNudgeLeft = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemNudgeRight = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barLinks = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.childFrameBarManager, "Links")
            Me.barItemLink = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemOrthogonalLink = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemDirectedLink = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemArcLink = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barRotate = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.childFrameBarManager, "Rotate")
            Me.barItemRotate = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemRotateLeft = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemRotateRight = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemFlipVertical = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemFlipHorizontal = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.bar1 = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.childFrameBarManager, "View")
            Me.barItemPan = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemShowGrid = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemSnapToGrid = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemZoom = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.comboBoxBarItemMagnification = New Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem
            Me.bar2 = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.childFrameBarManager, "Text Formatting")
            Me.comboBoxBarItemFontFamily = New Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem
            Me.comboBoxBarItemPointSize = New Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem
            Me.barItemBoldText = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemItalicText = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemUnderlineText = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemAlignTextLeft = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemCenterText = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemAlignTextRight = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemTextColor = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemSubscript = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemSuperscript = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemLower = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemUpper = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.bar3 = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.childFrameBarManager, "Scripting")
            Me.barItemLoadScript = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemRunScript = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemEditScript = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemStopScript = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            CType(Me.diagramComponent, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.diagramComponent.Model, System.ComponentModel.ISupportInitialize).BeginInit()
            CType(Me.childFrameBarManager, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.SuspendLayout()
            ' 
            ' diagramComponent
            ' 
            Me.diagramComponent.AllowDrop = True
            ' 
            ' diagramComponent.Controller
            ' 
            Me.diagramComponent.Controller.MaxHistory = 256
            Me.diagramComponent.Dock = System.Windows.Forms.DockStyle.Fill
            Me.diagramComponent.HScroll = True
            Me.diagramComponent.LayoutManager = Nothing
            Me.diagramComponent.Location = New System.Drawing.Point(0, 0)
            ' 
            ' diagramComponent.Model
            ' 
            Me.diagramComponent.Model.HeaderFooterData.Footer.Bounds.Width = 627.0F
            Me.diagramComponent.Model.HeaderFooterData.Header.Bounds.Width = 627.0F
            Me.diagramComponent.Model.Height = 1056.0F
            Me.diagramComponent.Model.Name = "Model"
            Me.diagramComponent.Model.Width = 816.0F
            Me.diagramComponent.Name = "diagramComponent"
            Me.diagramComponent.Size = New System.Drawing.Size(544, 414)
            Me.diagramComponent.SmartSizeBox = False
            Me.diagramComponent.TabIndex = 4
            Me.diagramComponent.VScroll = True
            '			Me.diagramComponent.ChildrenChanging += New Syncfusion.Windows.Forms.Diagram.NodeCollectionEventHandler(Me.diagramComponent_ChildrenChanging);
            '			Me.diagramComponent.ChildrenChangeComplete += New Syncfusion.Windows.Forms.Diagram.NodeCollectionEventHandler(Me.diagramComponent_ChildrenChangeComplete);
            ' 
            ' childFrameBarManager
            ' 
            Me.childFrameBarManager.BarPositionInfo = (CType(resources.GetObject("childFrameBarManager.BarPositionInfo"), System.IO.MemoryStream))
            Me.childFrameBarManager.Bars.Add(Me.barDrawing)
            Me.childFrameBarManager.Bars.Add(Me.barNode)
            Me.childFrameBarManager.Bars.Add(Me.barNudge)
            Me.childFrameBarManager.Bars.Add(Me.barLinks)
            Me.childFrameBarManager.Bars.Add(Me.barRotate)
            Me.childFrameBarManager.Bars.Add(Me.bar1)
            Me.childFrameBarManager.Bars.Add(Me.bar2)
            Me.childFrameBarManager.Bars.Add(Me.bar3)
            Me.childFrameBarManager.Categories.Add("Drawing Tools")
            Me.childFrameBarManager.Categories.Add("Node Tools")
            Me.childFrameBarManager.Categories.Add("Connection Tools")
            Me.childFrameBarManager.Categories.Add("Nudge Tools")
            Me.childFrameBarManager.Categories.Add("Rotate Tools")
            Me.childFrameBarManager.Categories.Add("View Tools")
            Me.childFrameBarManager.Categories.Add("Text Formatting")
            Me.childFrameBarManager.Categories.Add("Scripting")
            Me.childFrameBarManager.CurrentBaseFormType = "System.Windows.Forms.Form"
            Me.childFrameBarManager.Form = Me
            Me.childFrameBarManager.ImageList = Nothing
            Me.childFrameBarManager.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() {Me.barItemSelect, Me.barItemLine, Me.barItemRectangle, Me.barItemEllipse, Me.barItemText, Me.barItemPolyline, Me.barItemPolygon, Me.barItemArc, Me.barItemCurve, Me.barItemClosedCurve, Me.barItemImage, Me.barItemGroup, Me.barItemUngroup, Me.barItemBringToFront, Me.barItemSendToBack, Me.barItemBringForward, Me.barItemSendBackward, Me.barItemLink, Me.barItemNudgeUp, Me.barItemNudgeDown, Me.barItemNudgeLeft, Me.barItemNudgeRight, Me.barItemRotate, Me.barItemRotateLeft, Me.barItemRotateRight, Me.barItemFlipVertical, Me.barItemFlipHorizontal, Me.barItemPan, Me.barItemShowGrid, Me.barItemSnapToGrid, Me.barItemZoom, Me.comboBoxBarItemMagnification, Me.barItemOrthogonalLink, Me.barItemDirectedLink, Me.barItemArcLink, Me.barItemRichText, Me.barItemRoundRect, Me.barItemBoldText, Me.barItemItalicText, Me.barItemUnderlineText, Me.barItemAlignTextLeft, Me.barItemCenterText, Me.barItemAlignTextRight, Me.comboBoxBarItemFontFamily, Me.comboBoxBarItemPointSize, Me.barItemTextColor, Me.barItemLoadScript, Me.barItemRunScript, Me.barItemEditScript, Me.barItemStopScript, Me.barItemSuperscript, Me.barItemSubscript, Me.barItemUpper, Me.barItemLower})
            Me.childFrameBarManager.LargeImageList = Nothing
            Me.childFrameBarManager.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003
            ' 
            ' barDrawing
            ' 
            Me.barDrawing.BarName = "Drawing"
            Me.barDrawing.Caption = "Drawing"
            Me.barDrawing.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() {Me.barItemSelect, Me.barItemLine, Me.barItemPolyline, Me.barItemRectangle, Me.barItemRoundRect, Me.barItemEllipse, Me.barItemPolygon, Me.barItemCurve, Me.barItemClosedCurve, Me.barItemArc, Me.barItemText, Me.barItemRichText, Me.barItemImage})
            Me.barDrawing.Manager = Me.childFrameBarManager
            ' 
            ' barItemSelect
            ' 
            Me.barItemSelect.CategoryIndex = 0
            Me.barItemSelect.ID = "Pointer"
            Me.barItemSelect.ImageIndex = 0
            Me.barItemSelect.ImageList = Me.smBarItemImages
            Me.barItemSelect.Tag = "SelectTool"
            Me.barItemSelect.Text = "Select"
            Me.barItemSelect.Tooltip = "Select"
            '			Me.barItemSelect.Click += New System.EventHandler(Me.SelectToolActivate);
            ' 
            ' smBarItemImages
            ' 
            Me.smBarItemImages.ImageSize = New System.Drawing.Size(16, 16)
            Me.smBarItemImages.ImageStream = (CType(resources.GetObject("smBarItemImages.ImageStream"), System.Windows.Forms.ImageListStreamer))
            Me.smBarItemImages.TransparentColor = System.Drawing.Color.Fuchsia
            ' 
            ' barItemLine
            ' 
            Me.barItemLine.CategoryIndex = 0
            Me.barItemLine.ID = "Line"
            Me.barItemLine.ImageIndex = 1
            Me.barItemLine.ImageList = Me.smBarItemImages
            Me.barItemLine.Tag = "LineTool"
            Me.barItemLine.Text = "Line"
            Me.barItemLine.Tooltip = "Line"
            '			Me.barItemLine.Click += New System.EventHandler(Me.LineToolActivate);
            ' 
            ' barItemPolyline
            ' 
            Me.barItemPolyline.CategoryIndex = 0
            Me.barItemPolyline.ID = "Polyline"
            Me.barItemPolyline.ImageIndex = 2
            Me.barItemPolyline.ImageList = Me.smBarItemImages
            Me.barItemPolyline.Tag = "PolyLineTool"
            Me.barItemPolyline.Text = "Polyline"
            Me.barItemPolyline.Tooltip = "Polyline"
            '			Me.barItemPolyline.Click += New System.EventHandler(Me.PolylineToolActivate);
            ' 
            ' barItemRectangle
            ' 
            Me.barItemRectangle.CategoryIndex = 0
            Me.barItemRectangle.ID = "Rectangle"
            Me.barItemRectangle.ImageIndex = 4
            Me.barItemRectangle.ImageList = Me.smBarItemImages
            Me.barItemRectangle.Tag = "RectangleTool"
            Me.barItemRectangle.Text = "Rectangle"
            Me.barItemRectangle.Tooltip = "Rectangle"
            '			Me.barItemRectangle.Click += New System.EventHandler(Me.RectangleToolActivate);
            ' 
            ' barItemRoundRect
            ' 
            Me.barItemRoundRect.CategoryIndex = 0
            Me.barItemRoundRect.ID = "Rounded Rectangle"
            Me.barItemRoundRect.ImageIndex = 5
            Me.barItemRoundRect.ImageList = Me.smBarItemImages
            Me.barItemRoundRect.Tag = "RoundRectTool"
            Me.barItemRoundRect.Text = "Rounded Rectangle"
            '			Me.barItemRoundRect.Click += New System.EventHandler(Me.RoundedRectangleToolActivate);
            ' 
            ' barItemEllipse
            ' 
            Me.barItemEllipse.CategoryIndex = 0
            Me.barItemEllipse.ID = "Ellipse"
            Me.barItemEllipse.ImageIndex = 7
            Me.barItemEllipse.ImageList = Me.smBarItemImages
            Me.barItemEllipse.Tag = "EllipseTool"
            Me.barItemEllipse.Text = "Ellipse"
            Me.barItemEllipse.Tooltip = "Ellipse"
            '			Me.barItemEllipse.Click += New System.EventHandler(Me.EllipseToolActivate);
            ' 
            ' barItemPolygon
            ' 
            Me.barItemPolygon.CategoryIndex = 0
            Me.barItemPolygon.ID = "Polygon"
            Me.barItemPolygon.ImageIndex = 6
            Me.barItemPolygon.ImageList = Me.smBarItemImages
            Me.barItemPolygon.Tag = "PolygonTool"
            Me.barItemPolygon.Text = "Polygon"
            Me.barItemPolygon.Tooltip = "Polygon"
            '			Me.barItemPolygon.Click += New System.EventHandler(Me.PolygonToolActivate);
            ' 
            ' barItemCurve
            ' 
            Me.barItemCurve.CategoryIndex = 0
            Me.barItemCurve.ID = "Curve"
            Me.barItemCurve.ImageIndex = 9
            Me.barItemCurve.ImageList = Me.smBarItemImages
            Me.barItemCurve.Tag = "CurveTool"
            Me.barItemCurve.Text = "Curve"
            Me.barItemCurve.Tooltip = "Curve"
            '			Me.barItemCurve.Click += New System.EventHandler(Me.CurveToolActivate);
            ' 
            ' barItemClosedCurve
            ' 
            Me.barItemClosedCurve.CategoryIndex = 0
            Me.barItemClosedCurve.ID = "Closed Curve"
            Me.barItemClosedCurve.ImageIndex = 10
            Me.barItemClosedCurve.ImageList = Me.smBarItemImages
            Me.barItemClosedCurve.Tag = "ClosedCurveTool"
            Me.barItemClosedCurve.Text = "Closed Curve"
            Me.barItemClosedCurve.Tooltip = "Closed Curve"
            '			Me.barItemClosedCurve.Click += New System.EventHandler(Me.ClosedCurveToolActivate);
            ' 
            ' barItemArc
            ' 
            Me.barItemArc.CategoryIndex = 0
            Me.barItemArc.ID = "Arc"
            Me.barItemArc.ImageIndex = 8
            Me.barItemArc.ImageList = Me.smBarItemImages
            Me.barItemArc.Tag = "ArcTool"
            Me.barItemArc.Text = "Arc"
            Me.barItemArc.Tooltip = "Arc"
            '			Me.barItemArc.Click += New System.EventHandler(Me.ArcToolActivate);
            ' 
            ' barItemText
            ' 
            Me.barItemText.CategoryIndex = 0
            Me.barItemText.ID = "Text"
            Me.barItemText.ImageIndex = 12
            Me.barItemText.ImageList = Me.smBarItemImages
            Me.barItemText.Tag = "TextTool"
            Me.barItemText.Text = "Text"
            Me.barItemText.Tooltip = "Text"
            '			Me.barItemText.Click += New System.EventHandler(Me.TextToolActivate);
            ' 
            ' barItemRichText
            ' 
            Me.barItemRichText.CategoryIndex = 0
            Me.barItemRichText.ID = "Rich Text"
            Me.barItemRichText.ImageIndex = 48
            Me.barItemRichText.ImageList = Me.smBarItemImages
            Me.barItemRichText.Tag = "RichTextTool"
            Me.barItemRichText.Text = "Rich Text"
            Me.barItemRichText.Tooltip = "Rich Text"
            '			Me.barItemRichText.Click += New System.EventHandler(Me.RichTextToolActivate);
            ' 
            ' barItemImage
            ' 
            Me.barItemImage.CategoryIndex = 0
            Me.barItemImage.ID = "Image"
            Me.barItemImage.ImageIndex = 11
            Me.barItemImage.ImageList = Me.smBarItemImages
            Me.barItemImage.Tag = "ImageTool"
            Me.barItemImage.Text = "Image"
            Me.barItemImage.Tooltip = "Image"
            '			Me.barItemImage.Click += New System.EventHandler(Me.barItemImage_Click);
            ' 
            ' barNode
            ' 
            Me.barNode.BarName = "Node"
            Me.barNode.Caption = "Node"
            Me.barNode.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() {Me.barItemGroup, Me.barItemUngroup, Me.barItemBringToFront, Me.barItemSendToBack, Me.barItemBringForward, Me.barItemSendBackward})
            Me.barNode.Manager = Me.childFrameBarManager
            ' 
            ' barItemGroup
            ' 
            Me.barItemGroup.CategoryIndex = 1
            Me.barItemGroup.ID = "Group"
            Me.barItemGroup.ImageIndex = 14
            Me.barItemGroup.ImageList = Me.smBarItemImages
            Me.barItemGroup.Tag = "GroupTool"
            Me.barItemGroup.Text = "Group"
            Me.barItemGroup.Tooltip = "Group"
            '			Me.barItemGroup.Click += New System.EventHandler(Me.barItemGroup_Click);
            ' 
            ' barItemUngroup
            ' 
            Me.barItemUngroup.CategoryIndex = 1
            Me.barItemUngroup.ID = "Ungroup"
            Me.barItemUngroup.ImageIndex = 15
            Me.barItemUngroup.ImageList = Me.smBarItemImages
            Me.barItemUngroup.Tag = "UngroupTool"
            Me.barItemUngroup.Text = "Ungroup"
            Me.barItemUngroup.Tooltip = "Ungroup"
            '			Me.barItemUngroup.Click += New System.EventHandler(Me.barItemUngroup_Click);
            ' 
            ' barItemBringToFront
            ' 
            Me.barItemBringToFront.CategoryIndex = 1
            Me.barItemBringToFront.ID = "Bring To Front"
            Me.barItemBringToFront.ImageIndex = 41
            Me.barItemBringToFront.ImageList = Me.smBarItemImages
            Me.barItemBringToFront.Text = "Bring To Front"
            Me.barItemBringToFront.Tooltip = "Bring To Front"
            '			Me.barItemBringToFront.Click += New System.EventHandler(Me.barItemBringToFront_Click);
            ' 
            ' barItemSendToBack
            ' 
            Me.barItemSendToBack.CategoryIndex = 1
            Me.barItemSendToBack.ID = "Send To Back"
            Me.barItemSendToBack.ImageIndex = 43
            Me.barItemSendToBack.ImageList = Me.smBarItemImages
            Me.barItemSendToBack.Text = "Send To Back"
            '			Me.barItemSendToBack.Click += New System.EventHandler(Me.barItemSendToBack_Click);
            ' 
            ' barItemBringForward
            ' 
            Me.barItemBringForward.CategoryIndex = 1
            Me.barItemBringForward.ID = "Bring Forward"
            Me.barItemBringForward.ImageIndex = 40
            Me.barItemBringForward.ImageList = Me.smBarItemImages
            Me.barItemBringForward.Text = "Bring Forward"
            '			Me.barItemBringForward.Click += New System.EventHandler(Me.barItemBringForward_Click);
            ' 
            ' barItemSendBackward
            ' 
            Me.barItemSendBackward.CategoryIndex = 1
            Me.barItemSendBackward.ID = "Send Backward"
            Me.barItemSendBackward.ImageIndex = 42
            Me.barItemSendBackward.ImageList = Me.smBarItemImages
            Me.barItemSendBackward.Text = "Send Backward"
            '			Me.barItemSendBackward.Click += New System.EventHandler(Me.barItemSendBackward_Click);
            ' 
            ' barNudge
            ' 
            Me.barNudge.BarName = "Nudge"
            Me.barNudge.Caption = "Nudge"
            Me.barNudge.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() {Me.barItemNudgeUp, Me.barItemNudgeDown, Me.barItemNudgeLeft, Me.barItemNudgeRight})
            Me.barNudge.Manager = Me.childFrameBarManager
            ' 
            ' barItemNudgeUp
            ' 
            Me.barItemNudgeUp.CategoryIndex = 3
            Me.barItemNudgeUp.ID = "Nudge Up"
            Me.barItemNudgeUp.ImageIndex = 22
            Me.barItemNudgeUp.ImageList = Me.smBarItemImages
            Me.barItemNudgeUp.Text = "Nudge Up"
            Me.barItemNudgeUp.Tooltip = "Nudge Up"
            '			Me.barItemNudgeUp.Click += New System.EventHandler(Me.barItemNudgeUp_Click);
            ' 
            ' barItemNudgeDown
            ' 
            Me.barItemNudgeDown.CategoryIndex = 3
            Me.barItemNudgeDown.ID = "Nudge Down"
            Me.barItemNudgeDown.ImageIndex = 23
            Me.barItemNudgeDown.ImageList = Me.smBarItemImages
            Me.barItemNudgeDown.Text = "Nudge Down"
            Me.barItemNudgeDown.Tooltip = "Nudge Down"
            '			Me.barItemNudgeDown.Click += New System.EventHandler(Me.barItemNudgeDown_Click);
            ' 
            ' barItemNudgeLeft
            ' 
            Me.barItemNudgeLeft.CategoryIndex = 3
            Me.barItemNudgeLeft.ID = "Nudge Left"
            Me.barItemNudgeLeft.ImageIndex = 20
            Me.barItemNudgeLeft.ImageList = Me.smBarItemImages
            Me.barItemNudgeLeft.Text = "Nudge Left"
            Me.barItemNudgeLeft.Tooltip = "Nudge Left"
            '			Me.barItemNudgeLeft.Click += New System.EventHandler(Me.barItemNudgeLeft_Click);
            ' 
            ' barItemNudgeRight
            ' 
            Me.barItemNudgeRight.CategoryIndex = 3
            Me.barItemNudgeRight.ID = "Nudge Right"
            Me.barItemNudgeRight.ImageIndex = 21
            Me.barItemNudgeRight.ImageList = Me.smBarItemImages
            Me.barItemNudgeRight.Text = "Nudge Right"
            Me.barItemNudgeRight.Tooltip = "Nudge Right"
            '			Me.barItemNudgeRight.Click += New System.EventHandler(Me.barItemNudgeRight_Click);
            ' 
            ' barLinks
            ' 
            Me.barLinks.BarName = "Links"
            Me.barLinks.Caption = "Links"
            Me.barLinks.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() {Me.barItemLink, Me.barItemOrthogonalLink, Me.barItemDirectedLink, Me.barItemArcLink})
            Me.barLinks.Manager = Me.childFrameBarManager
            ' 
            ' barItemLink
            ' 
            Me.barItemLink.CategoryIndex = 2
            Me.barItemLink.ID = "Link"
            Me.barItemLink.ImageIndex = 44
            Me.barItemLink.ImageList = Me.smBarItemImages
            Me.barItemLink.Text = "Link"
            Me.barItemLink.Tooltip = "Link"
            '			Me.barItemLink.Click += New System.EventHandler(Me.barItemLinkSymbols_Click);
            ' 
            ' barItemOrthogonalLink
            ' 
            Me.barItemOrthogonalLink.CategoryIndex = 2
            Me.barItemOrthogonalLink.ID = "Orthogonal Link"
            Me.barItemOrthogonalLink.ImageIndex = 45
            Me.barItemOrthogonalLink.ImageList = Me.smBarItemImages
            Me.barItemOrthogonalLink.Text = "Orthogonal Link"
            '			Me.barItemOrthogonalLink.Click += New System.EventHandler(Me.barItemOrthogonalLink_Click);
            ' 
            ' barItemDirectedLink
            ' 
            Me.barItemDirectedLink.CategoryIndex = 2
            Me.barItemDirectedLink.ID = "Directed Link"
            Me.barItemDirectedLink.ImageIndex = 46
            Me.barItemDirectedLink.ImageList = Me.smBarItemImages
            Me.barItemDirectedLink.Text = "Directed Link"
            Me.barItemDirectedLink.Tooltip = "Directed Link"
            '			Me.barItemDirectedLink.Click += New System.EventHandler(Me.barItemDirectedLink_Click);
            ' 
            ' barItemArcLink
            ' 
            Me.barItemArcLink.CategoryIndex = 2
            Me.barItemArcLink.ID = "Arc Link"
            Me.barItemArcLink.ImageIndex = 47
            Me.barItemArcLink.ImageList = Me.smBarItemImages
            Me.barItemArcLink.Text = "Arc Link"
            Me.barItemArcLink.Tooltip = "Arc Link"
            '			Me.barItemArcLink.Click += New System.EventHandler(Me.barItemArcLink_Click);
            ' 
            ' barRotate
            ' 
            Me.barRotate.BarName = "Rotate"
            Me.barRotate.Caption = "Rotate"
            Me.barRotate.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() {Me.barItemRotate, Me.barItemRotateLeft, Me.barItemRotateRight, Me.barItemFlipVertical, Me.barItemFlipHorizontal})
            Me.barRotate.Manager = Me.childFrameBarManager
            ' 
            ' barItemRotate
            ' 
            Me.barItemRotate.CategoryIndex = 4
            Me.barItemRotate.ID = "Rotate"
            Me.barItemRotate.ImageIndex = 35
            Me.barItemRotate.ImageList = Me.smBarItemImages
            Me.barItemRotate.Tag = "RotateTool"
            Me.barItemRotate.Text = "Rotate"
            Me.barItemRotate.Tooltip = "Rotate"
            '			Me.barItemRotate.Click += New System.EventHandler(Me.RotateToolActivate);
            ' 
            ' barItemRotateLeft
            ' 
            Me.barItemRotateLeft.CategoryIndex = 4
            Me.barItemRotateLeft.ID = "Rotate Left"
            Me.barItemRotateLeft.ImageIndex = 36
            Me.barItemRotateLeft.ImageList = Me.smBarItemImages
            Me.barItemRotateLeft.Text = "Rotate Left"
            Me.barItemRotateLeft.Tooltip = "Rotate Left"
            '			Me.barItemRotateLeft.Click += New System.EventHandler(Me.barItemRotateLeft_Click);
            ' 
            ' barItemRotateRight
            ' 
            Me.barItemRotateRight.CategoryIndex = 4
            Me.barItemRotateRight.ID = "Rotate Right"
            Me.barItemRotateRight.ImageIndex = 37
            Me.barItemRotateRight.ImageList = Me.smBarItemImages
            Me.barItemRotateRight.Text = "Rotate Right"
            Me.barItemRotateRight.Tooltip = "Rotate Right"
            '			Me.barItemRotateRight.Click += New System.EventHandler(Me.barItemRotateRight_Click);
            ' 
            ' barItemFlipVertical
            ' 
            Me.barItemFlipVertical.CategoryIndex = 4
            Me.barItemFlipVertical.ID = "Flip Vertical"
            Me.barItemFlipVertical.ImageIndex = 39
            Me.barItemFlipVertical.ImageList = Me.smBarItemImages
            Me.barItemFlipVertical.Text = "Flip Vertical"
            Me.barItemFlipVertical.Tooltip = "Flip Vertical"
            '			Me.barItemFlipVertical.Click += New System.EventHandler(Me.barItemFlipVertical_Click);
            ' 
            ' barItemFlipHorizontal
            ' 
            Me.barItemFlipHorizontal.CategoryIndex = 4
            Me.barItemFlipHorizontal.ID = "Flip Horizontal"
            Me.barItemFlipHorizontal.ImageIndex = 38
            Me.barItemFlipHorizontal.ImageList = Me.smBarItemImages
            Me.barItemFlipHorizontal.Text = "Flip Horizontal"
            Me.barItemFlipHorizontal.Tooltip = "Flip Horizontal"
            '			Me.barItemFlipHorizontal.Click += New System.EventHandler(Me.barItemFlipHorizontal_Click);
            ' 
            ' bar1
            ' 
            Me.bar1.BarName = "View"
            Me.bar1.Caption = "View"
            Me.bar1.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() {Me.barItemPan, Me.barItemShowGrid, Me.barItemSnapToGrid, Me.barItemZoom, Me.comboBoxBarItemMagnification})
            Me.bar1.Manager = Me.childFrameBarManager
            ' 
            ' barItemPan
            ' 
            Me.barItemPan.CategoryIndex = 5
            Me.barItemPan.ID = "Pan"
            Me.barItemPan.ImageIndex = 16
            Me.barItemPan.ImageList = Me.smBarItemImages
            Me.barItemPan.Tag = "PanTool"
            Me.barItemPan.Text = "Pan"
            Me.barItemPan.Tooltip = "Pan"
            '			Me.barItemPan.Click += New System.EventHandler(Me.barItemPan_Click);
            ' 
            ' barItemShowGrid
            ' 
            Me.barItemShowGrid.CategoryIndex = 5
            Me.barItemShowGrid.ID = "Show Grid"
            Me.barItemShowGrid.ImageIndex = 18
            Me.barItemShowGrid.ImageList = Me.smBarItemImages
            Me.barItemShowGrid.Text = "Show Grid"
            Me.barItemShowGrid.Tooltip = "Show Grid"
            '			Me.barItemShowGrid.Click += New System.EventHandler(Me.barItemShowGrid_Click);
            ' 
            ' barItemSnapToGrid
            ' 
            Me.barItemSnapToGrid.CategoryIndex = 5
            Me.barItemSnapToGrid.ID = "Snap To Grid"
            Me.barItemSnapToGrid.ImageIndex = 19
            Me.barItemSnapToGrid.ImageList = Me.smBarItemImages
            Me.barItemSnapToGrid.Text = "Snap To Grid"
            '			Me.barItemSnapToGrid.Click += New System.EventHandler(Me.barItemSnapToGrid_Click);
            ' 
            ' barItemZoom
            ' 
            Me.barItemZoom.CategoryIndex = 5
            Me.barItemZoom.ID = "Zoom"
            Me.barItemZoom.ImageIndex = 17
            Me.barItemZoom.ImageList = Me.smBarItemImages
            Me.barItemZoom.Tag = "ZoomTool"
            Me.barItemZoom.Text = "Zoom"
            Me.barItemZoom.Tooltip = "Zoom"
            '			Me.barItemZoom.Click += New System.EventHandler(Me.ZoomToolActivate);
            ' 
            ' comboBoxBarItemMagnification
            ' 
            Me.comboBoxBarItemMagnification.CategoryIndex = 5
            Me.comboBoxBarItemMagnification.ChoiceList.AddRange(New String() {"25%", "50%", "75%", "100%", "125%", "150%", "175%", "200%"})
            Me.comboBoxBarItemMagnification.Editable = False
            Me.comboBoxBarItemMagnification.ID = "Magnification"
            Me.comboBoxBarItemMagnification.Text = "Magnification"
            Me.comboBoxBarItemMagnification.Tooltip = "Magnification"
            '			Me.comboBoxBarItemMagnification.Click += New System.EventHandler(Me.comboBoxBarItemMagnification_Click);
            ' 
            ' bar2
            ' 
            Me.bar2.BarName = "Text Formatting"
            Me.bar2.Caption = "Text Formatting"
            Me.bar2.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() {Me.comboBoxBarItemFontFamily, Me.comboBoxBarItemPointSize, Me.barItemBoldText, Me.barItemItalicText, Me.barItemUnderlineText, Me.barItemAlignTextLeft, Me.barItemCenterText, Me.barItemAlignTextRight, Me.barItemTextColor, Me.barItemSubscript, Me.barItemSuperscript, Me.barItemLower, Me.barItemUpper})
            Me.bar2.Manager = Me.childFrameBarManager
            ' 
            ' comboBoxBarItemFontFamily
            ' 
            Me.comboBoxBarItemFontFamily.CategoryIndex = 6
            Me.comboBoxBarItemFontFamily.Editable = False
            Me.comboBoxBarItemFontFamily.ID = "Font Family"
            Me.comboBoxBarItemFontFamily.MinWidth = 120
            Me.comboBoxBarItemFontFamily.Text = "Font Family"
            Me.comboBoxBarItemFontFamily.Tooltip = "Font Family"
            ' 
            ' comboBoxBarItemPointSize
            ' 
            Me.comboBoxBarItemPointSize.CategoryIndex = 6
            Me.comboBoxBarItemPointSize.ID = "Point Size"
            Me.comboBoxBarItemPointSize.Text = "Point Size"
            ' 
            ' barItemBoldText
            ' 
            Me.barItemBoldText.CategoryIndex = 6
            Me.barItemBoldText.ID = "Bold"
            Me.barItemBoldText.ImageIndex = 49
            Me.barItemBoldText.ImageList = Me.smBarItemImages
            Me.barItemBoldText.Text = "Bold"
            Me.barItemBoldText.Tooltip = "Bold"
            '			Me.barItemBoldText.Click += New System.EventHandler(Me.barItemBoldText_Click);
            ' 
            ' barItemItalicText
            ' 
            Me.barItemItalicText.CategoryIndex = 6
            Me.barItemItalicText.ID = "Italic"
            Me.barItemItalicText.ImageIndex = 50
            Me.barItemItalicText.ImageList = Me.smBarItemImages
            Me.barItemItalicText.Text = "Italic"
            Me.barItemItalicText.Tooltip = "Italic"
            '			Me.barItemItalicText.Click += New System.EventHandler(Me.barItemItalicText_Click);
            ' 
            ' barItemUnderlineText
            ' 
            Me.barItemUnderlineText.CategoryIndex = 6
            Me.barItemUnderlineText.ID = "Underline"
            Me.barItemUnderlineText.ImageIndex = 51
            Me.barItemUnderlineText.ImageList = Me.smBarItemImages
            Me.barItemUnderlineText.Text = "Underline"
            Me.barItemUnderlineText.Tooltip = "Underline"
            '			Me.barItemUnderlineText.Click += New System.EventHandler(Me.barItemUnderlineText_Click);
            ' 
            ' barItemAlignTextLeft
            ' 
            Me.barItemAlignTextLeft.CategoryIndex = 6
            Me.barItemAlignTextLeft.ID = "Align Text Left"
            Me.barItemAlignTextLeft.ImageIndex = 52
            Me.barItemAlignTextLeft.ImageList = Me.smBarItemImages
            Me.barItemAlignTextLeft.Text = "Align Text Left"
            Me.barItemAlignTextLeft.Tooltip = "Align Text Left"
            '			Me.barItemAlignTextLeft.Click += New System.EventHandler(Me.barItemAlignTextLeft_Click);
            ' 
            ' barItemCenterText
            ' 
            Me.barItemCenterText.CategoryIndex = 6
            Me.barItemCenterText.ID = "Center Text"
            Me.barItemCenterText.ImageIndex = 53
            Me.barItemCenterText.ImageList = Me.smBarItemImages
            Me.barItemCenterText.Text = "Center Text"
            Me.barItemCenterText.Tooltip = "Center Text"
            '			Me.barItemCenterText.Click += New System.EventHandler(Me.barItemCenterText_Click);
            ' 
            ' barItemAlignTextRight
            ' 
            Me.barItemAlignTextRight.CategoryIndex = 6
            Me.barItemAlignTextRight.ID = "Align Text Right"
            Me.barItemAlignTextRight.ImageIndex = 54
            Me.barItemAlignTextRight.ImageList = Me.smBarItemImages
            Me.barItemAlignTextRight.Text = "Align Text Right"
            Me.barItemAlignTextRight.Tooltip = "Align Text Right"
            '			Me.barItemAlignTextRight.Click += New System.EventHandler(Me.barItemAlignTextRight_Click);
            ' 
            ' barItemTextColor
            ' 
            Me.barItemTextColor.CategoryIndex = 6
            Me.barItemTextColor.ID = "Text Color"
            Me.barItemTextColor.ImageIndex = 55
            Me.barItemTextColor.ImageList = Me.smBarItemImages
            Me.barItemTextColor.Text = "Text Color"
            Me.barItemTextColor.Tooltip = "Text Color"
            '			Me.barItemTextColor.Click += New System.EventHandler(Me.barItemTextColor_Click);
            ' 
            ' barItemSubscript
            ' 
            Me.barItemSubscript.CategoryIndex = 6
            Me.barItemSubscript.ID = "Subscript"
            Me.barItemSubscript.ImageIndex = 61
            Me.barItemSubscript.ImageList = Me.smBarItemImages
            Me.barItemSubscript.Text = "Subscript"
            Me.barItemSubscript.Tooltip = "Subscript"
            '			Me.barItemSubscript.Click += New System.EventHandler(Me.barItemSubscript_Click);
            ' 
            ' barItemSuperscript
            ' 
            Me.barItemSuperscript.CategoryIndex = 6
            Me.barItemSuperscript.ID = "Superscript"
            Me.barItemSuperscript.ImageIndex = 60
            Me.barItemSuperscript.ImageList = Me.smBarItemImages
            Me.barItemSuperscript.Text = "Superscript"
            Me.barItemSuperscript.Tooltip = "Superscript"
            '			Me.barItemSuperscript.Click += New System.EventHandler(Me.barItemSuperscript_Click);
            ' 
            ' barItemLower
            ' 
            Me.barItemLower.CategoryIndex = 6
            Me.barItemLower.ID = "Lower"
            Me.barItemLower.ImageIndex = 63
            Me.barItemLower.ImageList = Me.smBarItemImages
            Me.barItemLower.Text = "Lower"
            '			Me.barItemLower.Click += New System.EventHandler(Me.barItemLower_Click);
            ' 
            ' barItemUpper
            ' 
            Me.barItemUpper.CategoryIndex = 6
            Me.barItemUpper.ID = "Upper"
            Me.barItemUpper.ImageIndex = 62
            Me.barItemUpper.ImageList = Me.smBarItemImages
            Me.barItemUpper.Text = "Upper"
            '			Me.barItemUpper.Click += New System.EventHandler(Me.barItemUpper_Click);
            ' 
            ' bar3
            ' 
            Me.bar3.BarName = "Scripting"
            Me.bar3.Caption = "Scripting"
            Me.bar3.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() {Me.barItemLoadScript, Me.barItemRunScript, Me.barItemEditScript, Me.barItemStopScript})
            Me.bar3.Manager = Me.childFrameBarManager
            ' 
            ' barItemLoadScript
            ' 
            Me.barItemLoadScript.CategoryIndex = 7
            Me.barItemLoadScript.ID = "Load Script"
            Me.barItemLoadScript.ImageIndex = 56
            Me.barItemLoadScript.ImageList = Me.smBarItemImages
            Me.barItemLoadScript.Text = "Load Script"
            Me.barItemLoadScript.Tooltip = "Load Script"
            '			Me.barItemLoadScript.Click += New System.EventHandler(Me.barItemLoadScript_Click);
            ' 
            ' barItemRunScript
            ' 
            Me.barItemRunScript.CategoryIndex = 7
            Me.barItemRunScript.ID = "Run Script"
            Me.barItemRunScript.ImageIndex = 57
            Me.barItemRunScript.ImageList = Me.smBarItemImages
            Me.barItemRunScript.Shortcut = System.Windows.Forms.Shortcut.F5
            Me.barItemRunScript.Text = "Run Script"
            Me.barItemRunScript.Tooltip = "Run Script"
            '			Me.barItemRunScript.Click += New System.EventHandler(Me.barItemRunScript_Click);
            ' 
            ' barItemEditScript
            ' 
            Me.barItemEditScript.CategoryIndex = 7
            Me.barItemEditScript.ID = "Edit Script"
            Me.barItemEditScript.ImageIndex = 58
            Me.barItemEditScript.ImageList = Me.smBarItemImages
            Me.barItemEditScript.Text = "Edit Script"
            Me.barItemEditScript.Tooltip = "Edit Script"
            '			Me.barItemEditScript.Click += New System.EventHandler(Me.barItemEditScript_Click);
            ' 
            ' barItemStopScript
            ' 
            Me.barItemStopScript.CategoryIndex = 7
            Me.barItemStopScript.ID = "Stop Script"
            Me.barItemStopScript.ImageIndex = 59
            Me.barItemStopScript.ImageList = Me.smBarItemImages
            Me.barItemStopScript.Shortcut = System.Windows.Forms.Shortcut.CtrlF5
            Me.barItemStopScript.Text = "Stop Script"
            Me.barItemStopScript.Tooltip = "Stop Script"
            '			Me.barItemStopScript.Click += New System.EventHandler(Me.barItemStopScript_Click);
            ' 
            ' DiagramForm
            ' 
            Me.AllowDrop = True
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(544, 414)
            Me.Controls.Add(Me.diagramComponent)
            Me.Name = "DiagramForm"
            Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show
            Me.Text = "Diagram"
            '			Me.Closing += New System.ComponentModel.CancelEventHandler(Me.DiagramForm_Closing);
            '			Me.Load += New System.EventHandler(Me.DiagramForm_Load);
            CType(Me.diagramComponent.Model, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.diagramComponent, System.ComponentModel.ISupportInitialize).EndInit()
            CType(Me.childFrameBarManager, System.ComponentModel.ISupportInitialize).EndInit()
            Me.ResumeLayout(False)

        End Sub
#End Region

        Protected Function CreateLink(ByVal pts As PointF()) As Link
            Dim link As link = New link(pts)
            'link.EndPoints.LastEndPoint = new FilledArrowDecorator();
            Return link
        End Function

        Protected Function CreateDirectedLink(ByVal pts As PointF()) As Link
            Dim link As link = New link(pts)
            Dim decoratorMdl As EndPointDecoratorModel = Syncfusion.Windows.Forms.Diagram.Global.EndPointDecoratorPalette("Filled Arrow")
            If Not decoratorMdl Is Nothing Then
                link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance()
            End If
            Return link
        End Function

        Protected Function CreateOrthogonalLink(ByVal pts As PointF()) As Link
            Dim link As link = New link(link.Shapes.OrthogonalLine, pts)
            Return link
        End Function

        Protected Function CreateDirectedOrthogonalLink(ByVal pts As PointF()) As Link
            Dim link As link = New link(link.Shapes.OrthogonalLine, pts)
            Dim decoratorMdl As EndPointDecoratorModel = Syncfusion.Windows.Forms.Diagram.Global.EndPointDecoratorPalette("Filled Arrow")
            If Not decoratorMdl Is Nothing Then
                link.EndPoints.LastEndPointDecorator = decoratorMdl.CreateInstance()
            End If
            Return link
        End Function

        Protected Function CreateArcLink(ByVal pts As PointF()) As Link
            Dim link As link = New link(link.Shapes.Arc, pts)
            Return link
        End Function

        Private Sub UpdateMagnificationComboBox()
            Dim szMag As System.Drawing.Size = Me.diagramComponent.View.Magnification
            Me.comboBoxBarItemMagnification.TextBoxValue = szMag.Width & "%"
        End Sub
        Protected Sub OnSelectionChanged(ByVal sender As Object, ByVal evtArgs As NodeCollectionEventArgs)
            Me.UpdateUITextFormatting()
        End Sub

        Private Sub barItemLinkSymbols_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemLink.Click
            SetActiveTool("LinkTool")

            Dim barItemToSelect As BarItem = CType(IIf(TypeOf sender Is BarItem, sender, Nothing), BarItem)

            If Not barItemToSelect Is Nothing Then
                Me.ActiveToolBarItem = barItemToSelect
            End If
        End Sub

        Private Sub barItemShowGrid_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemShowGrid.Click
            Me.barItemShowGrid.Checked = Not Me.barItemShowGrid.Checked
            Me.diagramComponent.View.Grid.Visible = Me.barItemShowGrid.Checked
        End Sub

        Private Sub barItemSnapToGrid_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemSnapToGrid.Click
            Me.barItemSnapToGrid.Checked = Not Me.barItemSnapToGrid.Checked
            Me.diagramComponent.View.Grid.SnapToGrid = Me.barItemSnapToGrid.Checked
        End Sub

        Private Sub DiagramForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Me.barItemShowGrid.Checked = Me.diagramComponent.View.Grid.Visible
            Me.barItemSnapToGrid.Checked = Me.diagramComponent.View.Grid.SnapToGrid
            UpdateMagnificationComboBox()

            ' Set Active SelectTool
            SetActiveTool(CType(Nothing, Tool))
            Me.ActiveToolBarItem = Me.barItemSelect

            ' Populate Tools Hashtable
            Me.Tools.Add("SelectTool", Me.barItemSelect)
            Me.Tools.Add("RectangleTool", Me.barItemRectangle)
            Me.Tools.Add("ArcTool", Me.barItemArc)
            Me.Tools.Add("BitmapTool", Me.barItemImage)
            Me.Tools.Add("ClosedCurveTool", Me.barItemClosedCurve)
            Me.Tools.Add("CurveTool", Me.barItemCurve)
            Me.Tools.Add("EllipseTool", Me.barItemEllipse)
            Me.Tools.Add("RoundRectTool", Me.barItemRoundRect)
            Me.Tools.Add("LineTool", Me.barItemLine)
            Me.Tools.Add("RichTextTool", Me.barItemRichText)
            Me.Tools.Add("TextTool", Me.barItemText)
            Me.Tools.Add("RotateTool", Me.barItemRotate)
            Me.Tools.Add("ZoomTool", Me.barItemZoom)
            Me.Tools.Add("PanTool", Me.barItemPan)
            Me.Tools.Add("PolygonTool", Me.barItemPolygon)
            Me.Tools.Add("PolyLineTool", Me.barItemPolyline)
            Me.Tools.Add("LineLinkTool", Me.barItemLink)
            Me.Tools.Add("OrthogonalLinkTool", Me.barItemOrthogonalLink)
            Me.Tools.Add("ArcLinkTool", Me.barItemArcLink)
            Me.Tools.Add("DirectedLineLinkTool", Me.barItemDirectedLink)


            ' Attach link factory to the default link tool
            Dim linkTool As Tool = Me.diagramComponent.Controller.GetTool("LinkTool")
            If Not linkTool Is Nothing AndAlso linkTool.GetType() Is GetType(linkTool) Then
                CType(linkTool, linkTool).LinkFactory = New LinkFactory(AddressOf Me.CreateLink)
            End If

            ' Create and register a tool for orthogonal links
            Dim orthogonalLinkTool As orthogonalLinkTool = New orthogonalLinkTool(Me.diagramComponent.Controller)
            Me.diagramComponent.Controller.RegisterTool(orthogonalLinkTool)

            ' Create and register a tool for directed links
            Dim directedLinkTool As DirectedLineLinkTool = New DirectedLineLinkTool(Me.diagramComponent.Controller)
            Me.diagramComponent.Controller.RegisterTool(directedLinkTool)

            ' Create and register a tool for arc links
            Dim arcLinkTool As arcLinkTool = New arcLinkTool(Me.diagramComponent.Controller)
            Me.diagramComponent.Controller.RegisterTool(arcLinkTool)

            ' Set focus to the diagram control
            Me.diagramComponent.Focus()
        End Sub

        Private Sub comboBoxBarItemMagnification_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles comboBoxBarItemMagnification.Click
            Dim strMagValue As String = Me.comboBoxBarItemMagnification.TextBoxValue
            Dim idxPctSign As Integer = strMagValue.IndexOf("%"c)
            If idxPctSign >= 0 Then
                strMagValue = strMagValue.Remove(idxPctSign, 1)
            End If
            Dim magVal As Integer = System.Convert.ToInt32(strMagValue)
            Me.diagramComponent.View.Magnification = New System.Drawing.Size(magVal, magVal)
            Me.diagramComponent.Refresh()
        End Sub

        Private Sub diagramComponent_View_MagnificationChanged(ByVal sender As Object, ByVal evtArgs As ViewMagnificationEventArgs)
            UpdateMagnificationComboBox()
        End Sub

        Private Sub barItemBringToFront_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemBringToFront.Click
            Me.diagramComponent.Controller.BringToFront()
        End Sub

        Private Sub barItemSendToBack_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemSendToBack.Click
            Me.diagramComponent.Controller.SendToBack()
        End Sub

        Private Sub barItemBringForward_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemBringForward.Click
            Me.diagramComponent.Controller.BringForward()
        End Sub

        Private Sub barItemSendBackward_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemSendBackward.Click
            Me.diagramComponent.Controller.SendBackward()
        End Sub

        Private Sub barItemNudgeUp_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemNudgeUp.Click
            Me.diagramComponent.NudgeUp()
        End Sub

        Private Sub barItemNudgeDown_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemNudgeDown.Click
            Me.diagramComponent.NudgeDown()
        End Sub

        Private Sub barItemNudgeLeft_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemNudgeLeft.Click
            Me.diagramComponent.NudgeLeft()
        End Sub

        Private Sub barItemNudgeRight_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemNudgeRight.Click
            Me.diagramComponent.NudgeRight()
        End Sub

        Private Sub barItemRotateLeft_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemRotateLeft.Click
            Me.diagramComponent.Rotate(-90)
        End Sub

        Private Sub barItemRotateRight_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemRotateRight.Click
            Me.diagramComponent.Rotate(90)
        End Sub

        Private Sub barItemFlipVertical_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemFlipVertical.Click
            Me.diagramComponent.FlipVertical()
        End Sub

        Private Sub barItemFlipHorizontal_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemFlipHorizontal.Click
            Me.diagramComponent.FlipHorizontal()
        End Sub

        Private Sub barItemImage_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemImage.Click
            SetActiveTool("BitmapTool")
            'this.diagramComponent.InsertImage();
        End Sub

        Private Sub DiagramForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
            Dim propEditor As Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor = Me.PropertyEditor
            If Not propEditor Is Nothing Then
                propEditor.Diagram = Nothing
            End If
        End Sub

        Private Sub barItemOrthogonalLink_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemOrthogonalLink.Click
            'this.diagramComponent.ActivateTool("OrthogonalLinkTool");
            SetActiveTool("OrthogonalLinkTool")

            Dim barItemToSelect As BarItem = CType(IIf(TypeOf sender Is BarItem, sender, Nothing), BarItem)

            If Not barItemToSelect Is Nothing Then
                Me.ActiveToolBarItem = barItemToSelect
            End If
        End Sub

        Private Sub barItemDirectedLink_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemDirectedLink.Click
            '	this.diagramComponent.ActivateTool("DirectedLinkTool");
            SetActiveTool("DirectedLineLinkTool")

            Dim barItemToSelect As BarItem = CType(IIf(TypeOf sender Is BarItem, sender, Nothing), BarItem)

            If Not barItemToSelect Is Nothing Then
                Me.ActiveToolBarItem = barItemToSelect
            End If
        End Sub

        Private Sub barItemArcLink_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemArcLink.Click
            'this.diagramComponent.ActivateTool("ArcLinkTool");
            SetActiveTool("ArcLinkTool")

            Dim barItemToSelect As BarItem = CType(IIf(TypeOf sender Is BarItem, sender, Nothing), BarItem)

            If Not barItemToSelect Is Nothing Then
                Me.ActiveToolBarItem = barItemToSelect
            End If
        End Sub

        Private Sub LoadFontSelections()
            ' Create ListBox containing names of font families and attach it to the
            ' font family combo box bar item
            Me.comboBoxBarItemFontFamily.ListBox = New ListBox
            Dim curFontFamily As FontFamily
            For Each curFontFamily In System.Drawing.FontFamily.Families
                Me.comboBoxBarItemFontFamily.ListBox.Items.Add(curFontFamily.Name)
            Next curFontFamily
            AddHandler comboBoxBarItemFontFamily.ListBox.SelectedIndexChanged, AddressOf FontFamily_SelectedIndexChanged

            ' Create ListBox containing point sizes and attach to the point size combo
            ' box bar item
            Dim pointSizeListBox As ListBox = New ListBox
            Dim ptSizes As Integer() = New Integer() {8, 9, 10, 11, 12, 14, 16, 18, 20, 22, 24, 26, 28, 36, 48, 72}
            Dim ptSize As Integer
            For Each ptSize In ptSizes
                pointSizeListBox.Items.Add(ptSize)
            Next ptSize
            Me.comboBoxBarItemPointSize.ListBox = pointSizeListBox
            AddHandler comboBoxBarItemPointSize.ListBox.SelectedIndexChanged, AddressOf PointSize_SelectedIndexChanged
        End Sub

        Private Sub FontFamily_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs)
            'Dim selectedIdx As Integer = Me.comboBoxBarItemFontFamily.ListBox.SelectedIndex
            'If selectedIdx >= 0 Then
            '    Dim fontFamily As String = CStr(Me.comboBoxBarItemFontFamily.ListBox.Items(selectedIdx))
            '    Me.diagramComponent.Controller.TextFormatter.FontFamily = fontFamily
            'End If

            Dim strFamilyName As String = Me.comboBoxBarItemFontFamily.ListBox.SelectedItem.ToString()

            If Me.diagramComponent.Controller.TextEditor.FamilyName <> strFamilyName Then
                Me.diagramComponent.Controller.TextEditor.FamilyName = strFamilyName
            End If
            Me.diagramComponent.Controller.TextEditor.FamilyName = strFamilyName
        End Sub

        Private Sub PointSize_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs)
            Dim selectedIdx As Integer = Me.comboBoxBarItemPointSize.ListBox.SelectedIndex
            If selectedIdx >= 0 Then
                Dim ptSize As Integer = CInt(Me.comboBoxBarItemPointSize.ListBox.Items(selectedIdx))
                Me.diagramComponent.Controller.TextEditor.PointSize = CSng(ptSize)
            End If
        End Sub

        Private Sub UpdateUITextFormatting()
            Dim controller As Syncfusion.Windows.Forms.Diagram.DiagramController = Me.diagramComponent.Controller

            If controller Is Nothing OrElse controller.TextEditor Is Nothing Then
                Return
            End If

            ' Update FamilyName
            Me.comboBoxBarItemFontFamily.TextBoxValue = controller.TextEditor.FamilyName

            Me.barItemBoldText.Checked = controller.TextEditor.Bold
            Me.barItemItalicText.Checked = controller.TextEditor.Italic
            Me.barItemUnderlineText.Checked = controller.TextEditor.Underline

            ' Update point size bar item
            Dim ptSize As Single = controller.TextEditor.PointSize

            If ptSize = 0 Then
                Me.comboBoxBarItemPointSize.TextBoxValue = String.Empty
            Else
                Me.comboBoxBarItemPointSize.TextBoxValue = ptSize.ToString()
            End If

            ' Update strikeout, superscript, subscript
            Me.barItemStrikeoutText.Checked = controller.TextEditor.Strikeout
            Me.barItemSubscript.Checked = controller.TextEditor.Subscript
            Me.barItemSuperscript.Checked = controller.TextEditor.Superscript

            ' Update text alignment bar items
            Dim horzAlign As StringAlignment = controller.TextEditor.HorizontalAlignment

            Select Case horzAlign
                Case StringAlignment.Near
                    Me.CurrentAlignment = Me.barItemAlignTextLeft
                Case StringAlignment.Center
                    Me.CurrentAlignment = Me.barItemCenterText
                Case StringAlignment.Far
                    Me.CurrentAlignment = Me.barItemAlignTextRight
            End Select
        End Sub


        Private Sub barItemBoldText_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemBoldText.Click
            If (Not CheckTextSelecionNode()) Then
                Return
            End If

            Dim newValue As Boolean = Not (Me.diagramComponent.Controller.TextEditor.Bold)
            Me.diagramComponent.Controller.TextEditor.Bold = newValue
            Me.barItemBoldText.Checked = newValue
        End Sub

        Private Sub barItemItalicText_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemItalicText.Click
            If (Not CheckTextSelecionNode()) Then
                Return
            End If

            Dim newValue As Boolean = Not (Me.diagramComponent.Controller.TextEditor.Italic)
            Me.diagramComponent.Controller.TextEditor.Italic = newValue
            Me.barItemItalicText.Checked = newValue
        End Sub

        Private Sub barItemUnderlineText_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemUnderlineText.Click
            If (Not CheckTextSelecionNode()) Then
                Return
            End If

            Dim newValue As Boolean = Not (Me.diagramComponent.Controller.TextEditor.Underline)
            Me.diagramComponent.Controller.TextEditor.Underline = newValue
            Me.barItemUnderlineText.Checked = newValue
        End Sub

        Private Sub barItemTextColor_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemTextColor.Click
            Dim dlg As ColorDialog = New ColorDialog
            dlg.Color = Me.diagramComponent.Controller.TextEditor.TextColor
            If dlg.ShowDialog(Me) = DialogResult.OK Then
                Me.diagramComponent.Controller.TextEditor.TextColor = dlg.Color
            End If
        End Sub

        Private Sub barItemAlignTextLeft_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemAlignTextLeft.Click
            Me.diagramComponent.Controller.TextEditor.HorizontalAlignment = StringAlignment.Near
            Me.barItemAlignTextLeft.Checked = True
            Me.barItemCenterText.Checked = False
            Me.barItemAlignTextRight.Checked = False
        End Sub

        Private Sub barItemCenterText_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemCenterText.Click
            Me.diagramComponent.Controller.TextEditor.HorizontalAlignment = StringAlignment.Center
            Me.barItemCenterText.Checked = True
            Me.barItemAlignTextLeft.Checked = False
            Me.barItemAlignTextRight.Checked = False
        End Sub

        Private Sub barItemAlignTextRight_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemAlignTextRight.Click
            Me.diagramComponent.Controller.TextEditor.HorizontalAlignment = StringAlignment.Far
            Me.barItemAlignTextRight.Checked = True
            Me.barItemAlignTextLeft.Checked = False
            Me.barItemCenterText.Checked = False
        End Sub

        Private Sub barItemSubscript_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemSubscript.Click
            Dim newValue As Boolean = Not (Me.diagramComponent.Controller.TextEditor.Subscript)
            Me.diagramComponent.Controller.TextEditor.Subscript = newValue
        End Sub


        Private Sub barItemSuperscript_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemSuperscript.Click
            Dim newValue As Boolean = Not (Me.diagramComponent.Controller.TextEditor.Superscript)
            Me.diagramComponent.Controller.TextEditor.Superscript = newValue
        End Sub

        Private Sub barItemLower_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemLower.Click
            Dim nCurrentOffset As Integer = Me.diagramComponent.Controller.TextEditor.CharOffset
            nCurrentOffset -= 1
            Me.diagramComponent.Controller.TextEditor.CharOffset = nCurrentOffset
        End Sub

        Private Sub barItemUpper_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemUpper.Click
            Dim nCurrentOffset As Integer = Me.diagramComponent.Controller.TextEditor.CharOffset
            nCurrentOffset += 1
            Me.diagramComponent.Controller.TextEditor.CharOffset = nCurrentOffset
        End Sub

#Region "Scripting Support"

        ' Set up scripting support by creating and initializing the DiagramScriptSite and ScriptingManager
        Private Sub InitializeScriptingManager()
            Me.scriptingMgr = New Syncfusion.Scripting.ScriptingManager(New DiagramScriptSite(Me.diagramComponent), New DiagramScript)
            Dim exepath As String = Application.ExecutablePath.ToLower()
            Dim testscriptpath As String = exepath.Substring(0, exepath.IndexOf("diagrambuilder\vb")) + "diagrambuilder\vb\_TESTSCRIPT\testscript.vb"
            Me.scriptingMgr.LoadScript(testscriptpath)
            AddHandler Me.scriptingMgr.CompileError, AddressOf Me.scriptingMgr_CompileError
        End Sub

        Private Sub barItemLoadScript_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemLoadScript.Click
            Dim fileDlg As System.Windows.Forms.OpenFileDialog = New System.Windows.Forms.OpenFileDialog

            If fileDlg.ShowDialog(Me) = DialogResult.OK Then
                Dim sourceFile As String = fileDlg.FileName
                Me.scriptingMgr.LoadScript(sourceFile)
            End If
        End Sub

        Private Sub barItemRunScript_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemRunScript.Click
            Dim compiled As Boolean = False

            If Me.scriptingMgr.NeedToCompile Then
                If Me.scriptingMgr.ApplicationBase = String.Empty Then
                    Me.scriptingMgr.ApplicationBase = New DirectoryInfo(GetAssembliesPath()).FullName
                End If
                compiled = Me.scriptingMgr.CompileScript()
            Else
                compiled = True
                '			}

                If compiled Then
                    Me.scriptingMgr.RunScript()
                End If
            End If
        End Sub

        Private Sub barItemEditScript_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemEditScript.Click
            ' Create the ScriptEditControl and initialize it with the diagram's ScriptingManager instance
            Dim scripteditform As Syncfusion.Scripting.Design.ScriptEditForm = New Syncfusion.Scripting.Design.ScriptEditForm
            Dim scriptedit As ScriptEditControl = scripteditform.ScriptEditControl
            scriptedit.InitializeScriptEditor(Me.scriptingMgr)
            ' Disable external compilation
            scriptedit.EnableExternalCompile = True
            ' Show the ScriptEditForm as a modal dialog
            scripteditform.ShowDialog(Me)
            scripteditform.Dispose()
        End Sub

        Private Sub barItemStopScript_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemStopScript.Click
            If Me.scriptingMgr.IsScriptRunning Then
                Me.scriptingMgr.ResetScriptEngine()
            End If
        End Sub

        Private Sub scripteEditControl_CompileScript(ByVal sender As Object, ByVal evtArgs As EventArgs)
            Me.scriptingMgr.ApplicationBase = New DirectoryInfo(GetAssembliesPath()).FullName
            Me.scriptingMgr.CompileScript()
        End Sub

        Private Sub scriptingMgr_CompileError(ByVal sender As Object, ByVal evtArgs As VsaErrorEventArgs)
            Trace.WriteLine("Error compiling script: " & evtArgs.Error.Description)
        End Sub

        Private Shared Function GetAssembliesPath() As String
            Dim assembliesfolder As String = GetNETVersion()
            Dim exepath As String = Application.ExecutablePath.ToLower()
            Dim subpath As String = exepath.Substring(0, exepath.IndexOf("\windows\diagram.windows\"))
            Dim assembliespath As String = subpath & "\precompiledassemblies\" & subpath.Substring(subpath.LastIndexOf("\"c) + 1) & "\" & assembliesfolder
            Return assembliespath
        End Function

        Private Shared Function GetNETVersion() As String
            Dim assemblies As System.Reflection.Assembly() = AppDomain.CurrentDomain.GetAssemblies()
            Dim assmbly As System.Reflection.Assembly
            For Each assmbly In assemblies
                Dim location As String = assmbly.Location
                If location.IndexOf("mscorlib.dll") >= 0 Then
                    If location.IndexOf("v1.0") >= 0 Then
                        Return "1.0"
                    ElseIf location.IndexOf("v1.1") >= 0 Then
                        Return "1.1"
                    Else
                        Return "2.0"
                    End If
                End If
            Next assmbly
            Return "1.1"
        End Function

#End Region   ' Scripting Support

#Region "DynamicLinks"

        ' If a symbol designated as a 'connector' is being added and the symbol's first node is a valid 
        ' endpoint container then insert the child shape in place of the symbol. Replacing the symbol with the 
        ' the child node allows us to designate the node as a dynamic link.
        Private Sub diagramComponent_ChildrenChanging(ByVal sender As Object, ByVal evtArgs As Syncfusion.Windows.Forms.Diagram.NodeCollectionEventArgs) Handles diagramComponent.ChildrenChanging
            If evtArgs.ChangeType = CollectionExChangeType.Insert Then
                Dim node As INode
                For Each node In evtArgs.Nodes
                    If (TypeOf node Is Symbol) AndAlso (Not node.Name Is Nothing) AndAlso (node.Name.ToLower().IndexOf("connector") >= 0) Then
                        Dim symbolnode As Symbol = CType(IIf(TypeOf node Is Symbol, node, Nothing), Symbol)
                        Dim childnode As INode = symbolnode.Nodes.First
                        If (TypeOf childnode Is Line) OrElse (TypeOf childnode Is PolyLine) OrElse (TypeOf childnode Is Arc) Then
                            Dim childshape As Shape = CType(IIf(TypeOf childnode Is Shape, childnode, Nothing), Shape)
                            Dim location As PointF = symbolnode.Location
                            symbolnode.Nodes.Remove(childshape)
                            childshape.LocalTransform.Reset()
                            Dim inscmd As InsertNodesCmd = New InsertNodesCmd(Me.Diagram.Controller.Model, childnode, location)
                            inscmd.Nodes.Add(childnode)

                            Me.diagramComponent.Controller.ExecuteCommand(inscmd)
                            evtArgs.Cancel = True
                        End If
                    End If
                Next node
            End If
        End Sub

        ' If a Line, PolyLine or Arc node is added to the diagram, set its EnableDynamicLinking property. 
        ' Setting this will deem the node as a shape that can be configured into a link by dragging it over a symbol.
        Private Sub diagramComponent_ChildrenChangeComplete(ByVal sender As Object, ByVal evtArgs As Syncfusion.Windows.Forms.Diagram.NodeCollectionEventArgs) Handles diagramComponent.ChildrenChangeComplete
            If evtArgs.ChangeType = CollectionExChangeType.Insert Then
                Dim node As INode
                For Each node In evtArgs.Nodes
                    If (TypeOf node Is Line) OrElse (TypeOf node Is PolyLine) OrElse (TypeOf node Is Arc) Then

                        Dim propcntnr As IPropertyContainer = CType(node.GetService(GetType(IPropertyContainer)), IPropertyContainer)
                        If Not propcntnr Is Nothing Then
                            propcntnr.SetPropertyValue("EnableDynamicLinking", True)
                        End If
                    End If
                Next node
            End If
        End Sub

        Private Function CheckTextSelecionNode() As Boolean
            Dim bResult As Boolean = False

            If diagramComponent.Controller Is Nothing Then
                Return bResult
            End If

            If diagramComponent.Controller.TextEditor.IsEditing Then
                bResult = True
            Else
                Dim selectionNodes As NodeCollection = Me.diagramComponent.Controller.SelectionList

                If Not selectionNodes Is Nothing Then
                    For Each node As INode In selectionNodes
                        If TypeOf node Is TextBase Then
                            bResult = True
                            Exit For
                        End If
                    Next node
                End If
            End If

            Return bResult
        End Function
#End Region   'DynamicLinks

        Private Sub LineToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemLine.Click
            'SetActiveTool( new LineTool( this.diagramComponent.Controller ) );
            SetActiveTool("LineTool")
        End Sub

        Private Sub RectangleToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemRectangle.Click
            SetActiveTool("RectangleTool")
        End Sub

        Private Sub SetActiveTool(ByVal toolActive As Tool)
            Me.diagramComponent.Controller.ActiveTool = toolActive
        End Sub

        Private Sub SetActiveTool(ByVal toolName As String)
            Me.diagramComponent.Controller.ActivateTool(toolName)
        End Sub

        Private Sub EllipseToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemEllipse.Click
            SetActiveTool("EllipseTool")
        End Sub

        Private Sub SelectToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemSelect.Click
            SetActiveTool("SelectTool")
        End Sub

        Private Sub PolygonToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemPolygon.Click
            SetActiveTool("PolygonTool")
        End Sub

        Private Sub PolylineToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemPolyline.Click
            SetActiveTool("PolyLineTool")
        End Sub

        Private Sub TextToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemText.Click
            SetActiveTool("TextTool")
        End Sub

        Private Sub ArcToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemArc.Click
            SetActiveTool("ArcTool")
        End Sub

        Private Sub RoundedRectangleToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemRoundRect.Click
            SetActiveTool("RoundRectTool")
        End Sub

        Private Sub CurveToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemCurve.Click
            SetActiveTool("CurveTool")
        End Sub

        Private Sub ClosedCurveToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemClosedCurve.Click
            SetActiveTool("ClosedCurveTool")
        End Sub

        Private Sub RichTextToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemRichText.Click
            SetActiveTool("RichTextTool")
        End Sub

        Private Sub ZoomToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemZoom.Click
            SetActiveTool("ZoomTool")
        End Sub


#Region "fields"
        Private m_hashControllerTools As Hashtable = Nothing
        Private m_BaritemActiveTool As BarItem = Nothing
#End Region

        Private Sub barItemGroup_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemGroup.Click
            diagramComponent.Controller.Group()
        End Sub

        Private Sub barItemUngroup_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemUngroup.Click
            diagramComponent.Controller.UnGroup()
        End Sub

        Private Sub barItemPan_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemPan.Click
            SetActiveTool("PanTool")

            '			BarItem barItemToSelect = sender as BarItem;

            '			if( barItemToSelect != null )
            '			{
            '				if( barItemToSelect.Equals( this.ActiveToolBarItem ) )
            '				{
            '					diagramComponent.Controller.ActiveTool = null;
            '					this.ActiveToolBarItem.Checked = false;
            '				}
            '				else
            '					this.ActiveToolBarItem = barItemToSelect;
            '			}
        End Sub

        Private Sub RotateToolActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemRotate.Click
            SetActiveTool("RotateTool")
        End Sub

        Private Sub Controller_ToolActivate(ByVal sender As Object, ByVal evtArgs As Syncfusion.Windows.Forms.Diagram.DiagramController.ToolEventArgs)
            evtArgs.Tool.SingleActionTool = False

            Dim strTool As String = GetToolQualifiedName(evtArgs.Tool.ToString())

            UpdateToolBars(strTool)
        End Sub

#Region "properties"
        Private Property Tools() As Hashtable
            Get
                If m_hashControllerTools Is Nothing Then
                    m_hashControllerTools = New Hashtable
                End If

                Return m_hashControllerTools
            End Get
            Set(ByVal Value As Hashtable)
                If Not m_hashControllerTools Is Value Then
                    m_hashControllerTools = Value
                End If
            End Set
        End Property
        Private Property ActiveToolBarItem() As BarItem
            Get
                Return m_BaritemActiveTool
            End Get
            Set(ByVal Value As BarItem)
                If Not m_BaritemActiveTool Is Value Then
                    If Not m_BaritemActiveTool Is Nothing Then
                        ' Uncheck
                        m_BaritemActiveTool.Checked = False
                    End If

                    ' Update baritem
                    m_BaritemActiveTool = Value
                    Me.diagramComponent.Focus()

                    If Not m_BaritemActiveTool Is Nothing Then
                        ' Check new baritem
                        m_BaritemActiveTool.Checked = True
                    End If
                End If
            End Set
        End Property
#End Region

#Region "helper methods"
        Private Function GetToolQualifiedName(ByVal strToolFullQuialifiedName As String) As String
            Dim regex As System.Text.RegularExpressions.Regex = New System.Text.RegularExpressions.Regex("\.")
            Dim strSplitNames As String() = regex.Split(strToolFullQuialifiedName)

            Return strSplitNames(strSplitNames.Length - 1)
        End Function

        Private Sub UpdateToolBars(ByVal strTool As String)
            If Me.Tools.Contains(strTool) Then
                Me.ActiveToolBarItem = CType(IIf(TypeOf Me.Tools(strTool) Is BarItem, Me.Tools(strTool), Nothing), BarItem)
            End If
        End Sub
#End Region
    End Class
End Namespace
