#Region "Copyright Syncfusion Inc. 2001 - 2005"
'
'  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
'
'  Use of this code is subject to the terms of our license.
'  A copy of the current license can be obtained at any time by e-mailing
'  licensing@syncfusion.com. Any infringement will be prosecuted under
'  applicable laws. 
'
#End Region

Imports System
Imports System.Drawing
Imports System.Collections
Imports System.Drawing.Drawing2D
Imports System.Drawing.Imaging
Imports System.Globalization
Imports System.Text
Imports System.Threading
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports System.Resources
Imports System.Drawing.Printing
Imports System.Text.RegularExpressions

Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.InteropServices
Imports System.Runtime.Serialization.Formatters
Imports System.Runtime.Serialization.Formatters.Soap

Imports Microsoft.Vsa
Imports Microsoft.VisualBasic
Imports Syncfusion.Runtime.InteropServices.WinAPI
Imports Syncfusion.Scripting
Imports Syncfusion.Windows.Forms.Tools
Imports Syncfusion.Windows.Forms.Diagram
Imports Syncfusion.SVG.IO
Imports Syncfusion.Windows.Forms.Diagram.Controls

Namespace Syncfusion.Windows.Forms.Diagram.Samples.DiagramTool
	''' <summary>
	''' MainForm for the Essential Diagram Builder.
	''' </summary>
	Public Class MainForm : Inherits System.Windows.Forms.Form
		#Region "Fields"

		Private WithEvents dockingManager As Syncfusion.Windows.Forms.Tools.DockingManager
		Private tabbedMDIManager As Syncfusion.Windows.Forms.Tools.TabbedMDIManager
		Private openPaletteDialog As System.Windows.Forms.OpenFileDialog
		Private openDiagramDialog As System.Windows.Forms.OpenFileDialog
		Private saveDiagramDialog As System.Windows.Forms.SaveFileDialog
		Private openImageDialog As System.Windows.Forms.OpenFileDialog
		Private barItem1 As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private symbolPaletteGroupBar As Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupBar
		Private mainFrameBarManager As Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager
		Private mainMenuBar As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private parentBarItem7 As Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem
		Private WithEvents biFileNew As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents biFileOpen As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents biFileSave As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents biFileSaveAs As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents biAddPalette As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents biFileExit As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents biTabbedMDI As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemEditCut As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemEditCopy As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemEditPaste As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemEditUndo As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemEditRedo As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemAbout As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private propertyEditor_Renamed As Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor
		Private standardToolbar As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private WithEvents biFilePrint As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents biPageSetup As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemViewSymbolPalette As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemViewProperties As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemEditSelectAll As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private parentBarItemEdit As Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem
		Private parentBarItemFile As Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem
		Private parentBarItemView As Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem
		Private parentBarItemWindow As Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem
		Private parentBarItemHelp As Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem
		Private smallImageList As System.Windows.Forms.ImageList
		Private WithEvents barItemDelete As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private resStringMgr As ResourceManager
		Private WithEvents biPrintPreview As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItemPanZoom As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private overviewControl1 As Syncfusion.Windows.Forms.Diagram.Controls.OverviewControl
        Private WithEvents barItemHeaderFooter As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
        Private WithEvents barItemPageBorders As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private components As System.ComponentModel.IContainer

		#End Region

		#Region "Constructors"

		Public Sub New()
			'
			' Required for Windows Form Designer support
			'
			InitializeComponent()

			'
			' Initialize tabbed MDI manager
			'
			tabbedMDIManager = New Syncfusion.Windows.Forms.Tools.TabbedMDIManager()
			tabbedMDIManager.AttachToMdiContainer(Me)

			' Create resource manager for strings
			Me.resStringMgr = New ResourceManager("Strings", GetType(MainForm).Assembly)

			' Wire up OnIdle processing
			AddHandler Application.Idle, AddressOf OnIdle
		End Sub

		''' <summary>
		''' Clean up any resources being used.
		''' </summary>
		Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
			If disposing Then
				If Not components Is Nothing Then
					components.Dispose()
				End If
			End If
			MyBase.Dispose(disposing)
		End Sub

		#End Region

		#Region "Windows Form Designer generated code"
		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
			Me.components = New System.ComponentModel.Container()
			Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(MainForm))
			Me.dockingManager = New Syncfusion.Windows.Forms.Tools.DockingManager(Me.components)
			Me.propertyEditor_Renamed = New Syncfusion.Windows.Forms.Diagram.Controls.PropertyEditor()
			Me.symbolPaletteGroupBar = New Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupBar()
			Me.overviewControl1 = New Syncfusion.Windows.Forms.Diagram.Controls.OverviewControl()
			Me.openPaletteDialog = New System.Windows.Forms.OpenFileDialog()
			Me.openDiagramDialog = New System.Windows.Forms.OpenFileDialog()
			Me.saveDiagramDialog = New System.Windows.Forms.SaveFileDialog()
			Me.smallImageList = New System.Windows.Forms.ImageList(Me.components)
			Me.openImageDialog = New System.Windows.Forms.OpenFileDialog()
			Me.barItem1 = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.mainFrameBarManager = New Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager(Me.components, Me)
			Me.mainMenuBar = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.mainFrameBarManager, "MainMenu")
			Me.parentBarItemFile = New Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem()
			Me.biFileNew = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.biFileOpen = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.biFileSave = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.biFileSaveAs = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.biAddPalette = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.biPageSetup = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.biPrintPreview = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.biFilePrint = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.biFileExit = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.parentBarItemEdit = New Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem()
			Me.barItemEditUndo = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.barItemEditRedo = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.barItemEditSelectAll = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.barItemEditCut = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.barItemEditCopy = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.barItemEditPaste = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.parentBarItemView = New Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem()
			Me.barItemViewSymbolPalette = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.barItemViewProperties = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.barItemPanZoom = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
            Me.barItemHeaderFooter = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
            Me.barItemPageBorders = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
			Me.parentBarItemWindow = New Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem()
			Me.biTabbedMDI = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.parentBarItemHelp = New Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem()
			Me.barItemAbout = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.standardToolbar = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.mainFrameBarManager, "Standard")
			Me.barItemDelete = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.parentBarItem7 = New Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem()
			CType(Me.dockingManager, System.ComponentModel.ISupportInitialize).BeginInit()
			CType(Me.mainFrameBarManager, System.ComponentModel.ISupportInitialize).BeginInit()
			' 
			' dockingManager
			' 
			Me.dockingManager.DockLayoutStream = (CType(resources.GetObject("dockingManager.DockLayoutStream"), System.IO.MemoryStream))
			Me.dockingManager.HostControl = Me
			Me.dockingManager.ShowToolTips = True
			Me.dockingManager.ThemesEnabled = True
'			Me.dockingManager.DockVisibilityChanged += New Syncfusion.Windows.Forms.Tools.DockVisibilityChangedEventHandler(Me.dockingManager_DockVisibilityChanged);
			Me.dockingManager.SetDockLabel(Me.propertyEditor_Renamed, "Properties")
			Me.dockingManager.SetDockLabel(Me.symbolPaletteGroupBar, "Symbol Palettes")
			Me.dockingManager.SetDockLabel(Me.overviewControl1, "Pan & Zoom")
			Me.dockingManager.SetHiddenOnLoad(Me.overviewControl1, True)
			' 
			' propertyEditor
			' 
			Me.propertyEditor_Renamed.Diagram = Nothing
			Me.dockingManager.SetEnableDocking(Me.propertyEditor_Renamed, True)
			Me.propertyEditor_Renamed.Location = New System.Drawing.Point(1, 21)
			Me.propertyEditor_Renamed.Name = "propertyEditor"
			Me.propertyEditor_Renamed.Size = New System.Drawing.Size(201, 492)
			Me.propertyEditor_Renamed.TabIndex = 11
			' 
			' symbolPaletteGroupBar
			' 
			Me.symbolPaletteGroupBar.AllowDrop = True
			Me.symbolPaletteGroupBar.EditMode = False
			Me.dockingManager.SetEnableDocking(Me.symbolPaletteGroupBar, True)
			Me.symbolPaletteGroupBar.Location = New System.Drawing.Point(1, 21)
			Me.symbolPaletteGroupBar.Name = "symbolPaletteGroupBar"
			Me.symbolPaletteGroupBar.Size = New System.Drawing.Size(139, 492)
			Me.symbolPaletteGroupBar.TabIndex = 9
			Me.symbolPaletteGroupBar.Text = "paletteGroupBar1"
			' 
			' overviewControl1
			' 
			Me.overviewControl1.BackColor = System.Drawing.SystemColors.AppWorkspace
			Me.dockingManager.SetEnableDocking(Me.overviewControl1, True)
			Me.overviewControl1.ForeColor = System.Drawing.Color.Red
			Me.overviewControl1.Location = New System.Drawing.Point(1, 1)
			Me.overviewControl1.Name = "overviewControl1"
			Me.overviewControl1.Size = New System.Drawing.Size(302, 305)
			Me.overviewControl1.TabIndex = 11
			' 
			' openPaletteDialog
			' 
			Me.openPaletteDialog.DefaultExt = "edp"
            Me.openPaletteDialog.Filter = "Essential Diagram Palettes|*.edp|Visio Stencils|*.vss; *.vsx|Visio Drawings(Shapes only)|*.vsd; *.vdx|All files|*.*"
			Me.openPaletteDialog.Title = "Add Palette"
			' 
			' openDiagramDialog
			' 
			Me.openDiagramDialog.Filter = "Diagram Files|*.edd|All files|*.*"
			Me.openDiagramDialog.Title = "Open Diagram"
			' 
			' saveDiagramDialog
			' 
			Me.saveDiagramDialog.FileName = "doc1"
            Me.saveDiagramDialog.Filter = "Diagram files|*.edd|EMF file|*.emf|GIF file|*.gif|PNG file|*.png|BMP file|*.bmp|JPEG file|*.jpeg,*.jpg|TIFF file|*.tiff|SVG file|*.svg|All files|*.*"
			' 
			' smallImageList
			' 
			Me.smallImageList.ImageSize = New System.Drawing.Size(16, 16)
			Me.smallImageList.ImageStream = (CType(resources.GetObject("smallImageList.ImageStream"), System.Windows.Forms.ImageListStreamer))
			Me.smallImageList.TransparentColor = System.Drawing.Color.Fuchsia
			' 
			' openImageDialog
			' 
			Me.openImageDialog.Filter = "Windows Bitmaps|*.bmp|Enhanced Metafiles|*.emf|All files|*.*"
			Me.openImageDialog.Title = "Insert Image"
			' 
			' barItem1
			' 
			Me.barItem1.CategoryIndex = 3
			Me.barItem1.ID = "Pan"
			Me.barItem1.ImageIndex = 10
			Me.barItem1.Tag = "PanTool"
			Me.barItem1.Text = "Pan"
			Me.barItem1.Tooltip = "Pan"
			' 
			' mainFrameBarManager
			' 
			Me.mainFrameBarManager.BarPositionInfo = (CType(resources.GetObject("mainFrameBarManager.BarPositionInfo"), System.IO.MemoryStream))
			Me.mainFrameBarManager.Bars.Add(Me.mainMenuBar)
			Me.mainFrameBarManager.Bars.Add(Me.standardToolbar)
			Me.mainFrameBarManager.Categories.Add("Popups")
			Me.mainFrameBarManager.Categories.Add("File")
			Me.mainFrameBarManager.Categories.Add("Window")
			Me.mainFrameBarManager.Categories.Add("Edit")
			Me.mainFrameBarManager.Categories.Add("Help")
			Me.mainFrameBarManager.Categories.Add("View")
			Me.mainFrameBarManager.Categories.Add("Dialogs")
			Me.mainFrameBarManager.CurrentBaseFormType = "System.Windows.Forms.Form"
			Me.mainFrameBarManager.DisabledImageList = Nothing
			Me.mainFrameBarManager.DisabledLargeImageList = Nothing
			Me.mainFrameBarManager.Form = Me
			Me.mainFrameBarManager.ImageList = Nothing
            Me.mainFrameBarManager.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() {Me.biFileNew, Me.biFileOpen, Me.biFileSave, Me.biFileSaveAs, Me.parentBarItemFile, Me.biPageSetup, Me.biPrintPreview, Me.biFilePrint, Me.biAddPalette, Me.parentBarItemEdit, Me.biFileExit, Me.parentBarItemView, Me.parentBarItemWindow, Me.parentBarItemHelp, Me.biTabbedMDI, Me.barItemEditCut, Me.barItemEditCopy, Me.barItemEditPaste, Me.barItemEditUndo, Me.barItemEditRedo, Me.barItemAbout, Me.barItemViewSymbolPalette, Me.barItemViewProperties, Me.barItemEditSelectAll, Me.barItemDelete, Me.barItemPanZoom, Me.barItemHeaderFooter, Me.barItemPageBorders})
			Me.mainFrameBarManager.LargeImageList = Nothing
			Me.mainFrameBarManager.ResetCustomization = False
			Me.mainFrameBarManager.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003
			' 
			' mainMenuBar
			' 
			Me.mainMenuBar.BarName = "MainMenu"
			Me.mainMenuBar.BarStyle = (CType(((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.IsMainMenu) Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.RotateWhenVertical) Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder), Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle))
			Me.mainMenuBar.Caption = "MainMenu"
			Me.mainMenuBar.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() { Me.parentBarItemFile, Me.parentBarItemEdit, Me.parentBarItemView, Me.parentBarItemWindow, Me.parentBarItemHelp})
			Me.mainMenuBar.Manager = Me.mainFrameBarManager
			' 
			' parentBarItemFile
			' 
			Me.parentBarItemFile.CategoryIndex = 0
			Me.parentBarItemFile.ID = "File"
			Me.parentBarItemFile.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() { Me.biFileNew, Me.biFileOpen, Me.biFileSave, Me.biFileSaveAs, Me.biAddPalette, Me.biPageSetup, Me.biPrintPreview, Me.biFilePrint, Me.biFileExit})
			Me.parentBarItemFile.SeparatorIndices.AddRange(New Integer() { 4, 5, 9})
			Me.parentBarItemFile.Text = "&File"
			' 
			' biFileNew
			' 
			Me.biFileNew.CategoryIndex = 1
			Me.biFileNew.ID = "New"
			Me.biFileNew.ImageIndex = 0
			Me.biFileNew.ImageList = Me.smallImageList
			Me.biFileNew.Shortcut = System.Windows.Forms.Shortcut.CtrlN
			Me.biFileNew.Text = "&New"
'			Me.biFileNew.Click += New System.EventHandler(Me.biFileNew_Click);
			' 
			' biFileOpen
			' 
			Me.biFileOpen.CategoryIndex = 1
			Me.biFileOpen.ID = "Open"
			Me.biFileOpen.ImageIndex = 1
			Me.biFileOpen.ImageList = Me.smallImageList
			Me.biFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
			Me.biFileOpen.Text = "&Open"
'			Me.biFileOpen.Click += New System.EventHandler(Me.biFileOpen_Click);
			' 
			' biFileSave
			' 
			Me.biFileSave.CategoryIndex = 1
			Me.biFileSave.ID = "Save"
			Me.biFileSave.ImageIndex = 2
			Me.biFileSave.ImageList = Me.smallImageList
			Me.biFileSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS
			Me.biFileSave.Text = "&Save"
'			Me.biFileSave.Click += New System.EventHandler(Me.biFileSave_Click);
			' 
			' biFileSaveAs
			' 
			Me.biFileSaveAs.CategoryIndex = 1
			Me.biFileSaveAs.ID = "Save As..."
			Me.biFileSaveAs.Text = "Save As..."
'			Me.biFileSaveAs.Click += New System.EventHandler(Me.biFileSaveAs_Click);
			' 
			' biAddPalette
			' 
			Me.biAddPalette.CategoryIndex = 1
			Me.biAddPalette.ID = "Add Palette"
			Me.biAddPalette.Text = "Add Palette"
'			Me.biAddPalette.Click += New System.EventHandler(Me.biFileAddPalette_Click);
			' 
			' biPageSetup
			' 
			Me.biPageSetup.CategoryIndex = 1
			Me.biPageSetup.ID = "Page Setup"
			Me.biPageSetup.ImageIndex = 8
			Me.biPageSetup.ImageList = Me.smallImageList
			Me.biPageSetup.Text = "Page Setup"
'			Me.biPageSetup.Click += New System.EventHandler(Me.biPageSetup_Click);
			' 
			' biPrintPreview
			' 
			Me.biPrintPreview.CategoryIndex = 1
			Me.biPrintPreview.ID = "Print Preview"
			Me.biPrintPreview.ImageIndex = 11
			Me.biPrintPreview.ImageList = Me.smallImageList
			Me.biPrintPreview.Text = "Print Preview"
			Me.biPrintPreview.Tooltip = "Print Preview"
'			Me.biPrintPreview.Click += New System.EventHandler(Me.biPrintPreview_Click);
			' 
			' biFilePrint
			' 
			Me.biFilePrint.CategoryIndex = 1
			Me.biFilePrint.ID = "Print"
			Me.biFilePrint.ImageIndex = 6
			Me.biFilePrint.ImageList = Me.smallImageList
			Me.biFilePrint.Text = "Print"
'			Me.biFilePrint.Click += New System.EventHandler(Me.biFilePrint_Click);
			' 
			' biFileExit
			' 
			Me.biFileExit.CategoryIndex = 1
			Me.biFileExit.ID = "Exit"
			Me.biFileExit.Text = "Exit"
'			Me.biFileExit.Click += New System.EventHandler(Me.biFileExit_Click);
			' 
			' parentBarItemEdit
			' 
			Me.parentBarItemEdit.CategoryIndex = 0
			Me.parentBarItemEdit.ID = "Edit"
			Me.parentBarItemEdit.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() { Me.barItemEditUndo, Me.barItemEditRedo, Me.barItemEditSelectAll, Me.barItemEditCut, Me.barItemEditCopy, Me.barItemEditPaste})
			Me.parentBarItemEdit.SeparatorIndices.AddRange(New Integer() { 2, 3})
			Me.parentBarItemEdit.Text = "&Edit"
			' 
			' barItemEditUndo
			' 
			Me.barItemEditUndo.CategoryIndex = 3
			Me.barItemEditUndo.ID = "Undo"
			Me.barItemEditUndo.ImageIndex = 9
			Me.barItemEditUndo.ImageList = Me.smallImageList
			Me.barItemEditUndo.Shortcut = System.Windows.Forms.Shortcut.CtrlZ
			Me.barItemEditUndo.Text = "&Undo"
'			Me.barItemEditUndo.Click += New System.EventHandler(Me.barItemEditUndo_Click);
			' 
			' barItemEditRedo
			' 
			Me.barItemEditRedo.CategoryIndex = 3
			Me.barItemEditRedo.ID = "EditRedo"
			Me.barItemEditRedo.ImageIndex = 10
			Me.barItemEditRedo.ImageList = Me.smallImageList
			Me.barItemEditRedo.Shortcut = System.Windows.Forms.Shortcut.CtrlY
			Me.barItemEditRedo.Text = "&Redo"
'			Me.barItemEditRedo.Click += New System.EventHandler(Me.barItemEditRedo_Click);
			' 
			' barItemEditSelectAll
			' 
			Me.barItemEditSelectAll.CategoryIndex = 3
			Me.barItemEditSelectAll.ID = "&Select All"
			Me.barItemEditSelectAll.Shortcut = System.Windows.Forms.Shortcut.CtrlA
			Me.barItemEditSelectAll.Text = "Select &All"
'			Me.barItemEditSelectAll.Click += New System.EventHandler(Me.barItemEditSelectAll_Click);
			' 
			' barItemEditCut
			' 
			Me.barItemEditCut.CategoryIndex = 3
			Me.barItemEditCut.ID = "Cut"
			Me.barItemEditCut.ImageIndex = 3
			Me.barItemEditCut.ImageList = Me.smallImageList
			Me.barItemEditCut.Shortcut = System.Windows.Forms.Shortcut.CtrlX
			Me.barItemEditCut.Text = "C&ut"
'			Me.barItemEditCut.Click += New System.EventHandler(Me.barItemEditCut_Click);
			' 
			' barItemEditCopy
			' 
			Me.barItemEditCopy.CategoryIndex = 3
			Me.barItemEditCopy.ID = "Copy"
			Me.barItemEditCopy.ImageIndex = 4
			Me.barItemEditCopy.ImageList = Me.smallImageList
			Me.barItemEditCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC
			Me.barItemEditCopy.Text = "&Copy"
'			Me.barItemEditCopy.Click += New System.EventHandler(Me.barItemEditCopy_Click);
			' 
			' barItemEditPaste
			' 
			Me.barItemEditPaste.CategoryIndex = 3
			Me.barItemEditPaste.ID = "Paste"
			Me.barItemEditPaste.ImageIndex = 5
			Me.barItemEditPaste.ImageList = Me.smallImageList
			Me.barItemEditPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV
			Me.barItemEditPaste.Text = "&Paste"
'			Me.barItemEditPaste.Click += New System.EventHandler(Me.barItemEditPaste_Click);
			' 
			' parentBarItemView
			' 
			Me.parentBarItemView.CategoryIndex = 0
			Me.parentBarItemView.ID = "View"
            Me.parentBarItemView.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() {Me.barItemViewSymbolPalette, Me.barItemViewProperties, Me.barItemPanZoom, Me.barItemHeaderFooter, Me.barItemPageBorders})
			Me.parentBarItemView.SeparatorIndices.AddRange(New Integer() { 3})
			Me.parentBarItemView.Text = "&View"
			' 
			' barItemViewSymbolPalette
			' 
			Me.barItemViewSymbolPalette.CategoryIndex = 5
			Me.barItemViewSymbolPalette.ID = "Symbol Palette"
			Me.barItemViewSymbolPalette.Text = "Symbol Palette"
'			Me.barItemViewSymbolPalette.Click += New System.EventHandler(Me.barItemViewSymbolPalette_Click);
			' 
			' barItemViewProperties
			' 
			Me.barItemViewProperties.CategoryIndex = 5
			Me.barItemViewProperties.ID = "Properties"
			Me.barItemViewProperties.Text = "Properties"
'			Me.barItemViewProperties.Click += New System.EventHandler(Me.barItemViewProperties_Click);
			' 
			' barItemPanZoom
			' 
			Me.barItemPanZoom.CategoryIndex = 5
			Me.barItemPanZoom.ID = "panZoomWindow"
			Me.barItemPanZoom.Text = "Pan & Zoom Window"
			Me.barItemPanZoom.Tooltip = "Pan & Zoom Window"
'			Me.barItemPanZoom.Click += New System.EventHandler(Me.barItemPanZoom_Click);
			' 
			' barItemHeaderFooter
			' 
			Me.barItemHeaderFooter.CategoryIndex = 5
			Me.barItemHeaderFooter.ID = "Header Footer"
			Me.barItemHeaderFooter.Text = "Header Footer"
            ' Me.barItemHeaderFooter.Click += New System.EventHandler(Me.barItemHeaderFooter_Click);
            ' 
            ' barItemPageBorders
            ' 
            Me.barItemPageBorders.CategoryIndex = 6
            Me.barItemPageBorders.ID = "Page Borders"
            Me.barItemPageBorders.Text = "Page Borders"
            ' Me.barItemPageBorders.Click += New System.EventHandler(Me.barItemPageBorders_Click);
			' 
			' parentBarItemWindow
			' 
			Me.parentBarItemWindow.CategoryIndex = 0
			Me.parentBarItemWindow.ID = "Window"
			Me.parentBarItemWindow.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() { Me.biTabbedMDI})
			Me.parentBarItemWindow.Text = "&Window"
			' 
			' biTabbedMDI
			' 
			Me.biTabbedMDI.CategoryIndex = 2
			Me.biTabbedMDI.Checked = True
			Me.biTabbedMDI.ID = "Tabbed MDI"
			Me.biTabbedMDI.Text = "Tabbed MDI"
'			Me.biTabbedMDI.Click += New System.EventHandler(Me.biTabbedMDI_Click);
			' 
			' parentBarItemHelp
			' 
			Me.parentBarItemHelp.CategoryIndex = 0
			Me.parentBarItemHelp.ID = "Help"
			Me.parentBarItemHelp.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() { Me.barItemAbout})
			Me.parentBarItemHelp.Text = "&Help"
			' 
			' barItemAbout
			' 
			Me.barItemAbout.CategoryIndex = 4
			Me.barItemAbout.ID = "About"
			Me.barItemAbout.Text = "About..."
'			Me.barItemAbout.Click += New System.EventHandler(Me.barItemAbout_Click);
			' 
			' standardToolbar
			' 
			Me.standardToolbar.BarName = "Standard"
			Me.standardToolbar.BarStyle = (CType((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.RotateWhenVertical) Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder), Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle))
			Me.standardToolbar.Caption = "Standard"
			Me.standardToolbar.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() { Me.biFileNew, Me.biFileOpen, Me.biFileSave, Me.biPrintPreview, Me.biFilePrint})
			Me.standardToolbar.Manager = Me.mainFrameBarManager
			' 
			' barItemDelete
			' 
			Me.barItemDelete.CategoryIndex = 3
			Me.barItemDelete.ID = "Delete"
			Me.barItemDelete.Shortcut = System.Windows.Forms.Shortcut.Del
			Me.barItemDelete.Text = "&Delete"
'			Me.barItemDelete.Click += New System.EventHandler(Me.barItemDelete_Click);
			' 
			' parentBarItem7
			' 
			Me.parentBarItem7.CategoryIndex = 3
			Me.parentBarItem7.ID = "Zoom"
			Me.parentBarItem7.ImageIndex = 8
			Me.parentBarItem7.Text = "Zoom"
			' 
			' MainForm
			' 
			Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
			Me.ClientSize = New System.Drawing.Size(792, 566)
			Me.IsMdiContainer = True
			Me.Name = "MainForm"
			Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
			Me.Text = "Diagram Builder"
'			Me.MdiChildActivate += New System.EventHandler(Me.MainForm_MdiChildActivate);
'			Me.Load += New System.EventHandler(Me.MainForm_Load);
			CType(Me.dockingManager, System.ComponentModel.ISupportInitialize).EndInit()
			CType(Me.mainFrameBarManager, System.ComponentModel.ISupportInitialize).EndInit()

		End Sub
		#End Region

		#Region "MainForm Event Handlers"

		Private Sub MainForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			Me.barItemViewProperties.Checked = True
			Me.barItemViewSymbolPalette.Checked = True

			'Load Palettes
			Dim exepath As String = Application.ExecutablePath.ToLower()
            Dim symbolpalettepath As String = exepath.Substring(0, exepath.IndexOf("diagrambuilder")) & "diagrambuilder\vb\symbol palettes"
            Me.symbolPaletteGroupBar.LoadPalette(symbolpalettepath & "\Basic Shapes.edp")
            Me.symbolPaletteGroupBar.LoadPalette(symbolpalettepath & "\Electrical Symbols.edp")
            Me.symbolPaletteGroupBar.LoadPalette(symbolpalettepath & "\Flowchart Symbols.edp")

			' New diagram
			Dim docForm As DiagramForm = New DiagramForm()
			docForm.MdiParent = Me
			AddHandler docForm.Closing, AddressOf DiagramForm_Closing
			docForm.Show()
		End Sub

		Private Sub MainForm_MdiChildActivate(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.MdiChildActivate
			Dim diagramForm As DiagramForm = CType(IIf(TypeOf Me.ActiveMdiChild Is DiagramForm, Me.ActiveMdiChild, Nothing), DiagramForm)
			If Not diagramForm Is Nothing Then
				Me.propertyEditor_Renamed.Diagram = diagramForm.Diagram

				' If the OverviewControl is visible then change the OverviewControl.Model and OverviewControl.View 
				' properties to reference the new diagram's Model and View
				If Me.dockingManager.GetDockVisibility(Me.overviewControl1) = True Then
					Me.overviewControl1.Model = diagramForm.Diagram.Model
					Me.overviewControl1.View = diagramForm.Diagram.View
				End If
			End If
		End Sub

		#End Region

		#Region "Properties"

		Private ReadOnly Property ActiveDiagram() As Syncfusion.Windows.Forms.Diagram.Controls.Diagram
			Get
				Dim diagram As Syncfusion.Windows.Forms.Diagram.Controls.Diagram = Nothing

				If Not Me.ActiveMdiChild Is Nothing Then
					Dim diagramForm As DiagramForm = CType(IIf(TypeOf Me.ActiveMdiChild Is DiagramForm, Me.ActiveMdiChild, Nothing), DiagramForm)
					If Not diagramForm Is Nothing Then
						diagram = diagramForm.Diagram
					End If
				End If

				Return diagram
			End Get
		End Property

		Private ReadOnly Property ActiveDiagramForm() As DiagramForm
			Get
				Dim diagramForm As DiagramForm = Nothing

				If Not Me.ActiveMdiChild Is Nothing Then
					diagramForm = CType(IIf(TypeOf Me.ActiveMdiChild Is DiagramForm, Me.ActiveMdiChild, Nothing), DiagramForm)
				End If

				Return diagramForm
			End Get
		End Property

		Public ReadOnly Property PropertyEditor() As PropertyEditor
			Get
				Return Me.propertyEditor_Renamed
			End Get
		End Property

		#End Region

		#Region "File Menu Event Handlers"

		Private Sub biFileAddPalette_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles biAddPalette.Click
			' Open symbol palette and add it to the symbol palette group bar
            If openPaletteDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK Then
                Dim curPalette As SymbolPalette = Nothing
                Dim iStream As FileStream = Nothing

                Dim strFileName As String = openPaletteDialog.FileName

                Dim options As RegexOptions = RegexOptions.IgnoreCase
                Dim match As Match = Regex.Match(strFileName, ".vss|.vsx|.vsd|.vdx", options)
                If match.Success Then
                    Dim converter As VisioStencilConverter = New VisioStencilConverter(strFileName, Me)
                    converter.ShowProgressDialog = True
                    '		  converter.IgnoreStyles = false;
                    curPalette = converter.Convert()
                    symbolPaletteGroupBar.AddPalette(curPalette)
                Else
                    Try
                        iStream = New FileStream(strFileName, FileMode.Open, FileAccess.Read)
                    Catch ex As Exception
                        iStream = Nothing
                        MessageBox.Show(Me, ex.Message)
                    End Try

                    If Not iStream Is Nothing Then
                        Dim formatter As SoapFormatter = New SoapFormatter()
                        formatter.Binder = Syncfusion.Runtime.Serialization.AppStateSerializer.CustomBinder
                        formatter.AssemblyFormat = FormatterAssemblyStyle.Simple
                        Try
                            AddHandler AppDomain.CurrentDomain.AssemblyResolve, AddressOf DiagramBaseAssembly.AssemblyResolver
                            curPalette = CType(formatter.Deserialize(iStream), SymbolPalette)
                            symbolPaletteGroupBar.AddPalette(curPalette)
                        Catch ex As Exception
                            MessageBox.Show(Me, ex.Message)
                        Finally
                            iStream.Close()
                        End Try
                    End If
                End If
            End If
		End Sub

		Private Sub biFileNew_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles biFileNew.Click
			' New diagram
			Dim docForm As DiagramForm = New DiagramForm()
			docForm.MdiParent = Me
			AddHandler docForm.Closing, AddressOf DiagramForm_Closing
			docForm.Show()
		End Sub

		Private Sub biFileOpen_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles biFileOpen.Click
			' Open diagram
            If Me.openDiagramDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK Then
                Dim docForm As DiagramForm = New DiagramForm()
                docForm.OpenFile(Me.openDiagramDialog.FileName)
                docForm.MdiParent = Me
                AddHandler docForm.Closing, AddressOf DiagramForm_Closing
                docForm.Show()
            End If
		End Sub

		Private Sub biFileSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles biFileSave.Click
			' Save diagram
			Dim docForm As DiagramForm = Me.ActiveDiagramForm
			If Not docForm Is Nothing Then
				If (Not docForm.HasFileName) Then
                    If Me.saveDiagramDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK Then
                        docForm.SaveAsFile(Me.saveDiagramDialog.FileName)
                    End If
				Else
					docForm.SaveFile()
				End If
			End If
		End Sub

		Private Sub biFileSaveAs_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles biFileSaveAs.Click
			' Save diagram
			Dim docForm As DiagramForm = Me.ActiveDiagramForm
			If Not docForm Is Nothing Then
				If docForm.HasFileName Then
					Me.saveDiagramDialog.FileName = docForm.FileName
				End If
                If Me.saveDiagramDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK Then
                    Dim strFileName As String = Me.saveDiagramDialog.FileName
                    ' search for file extension
                    Dim options As RegexOptions = RegexOptions.IgnoreCase
                    Dim match As Match = Regex.Match(strFileName, "([^.]*)$", options)
                    If match.Success Then
                        Dim imgDiagram As Image = Nothing
                        Select Case match.Value
                            Case "svg"
                                Dim tosvg As tosvg = New tosvg
                                ' Get Diagram Nodes Bounding Rectangle.
                                Dim rectBounding As RectangleF = Me.ActiveDiagramForm.Diagram.Model.GetBoundingRect()
                                Dim gfx As Graphics = tosvg.GetRealGraphics(New Size(CInt(rectBounding.Width), CInt(rectBounding.Height)))
                                Me.ActiveDiagram.ExportDiagramToGraphics(gfx)
                                tosvg.Save(strFileName)

                            Case "emf"
                                'Save Diagram to created image.
                                imgDiagram = Me.ActiveDiagram.ExportDiagramAsImage(False)
                                ' Save image as metafile.
                                imgDiagram.Save(strFileName, ImageFormat.Emf)
                            Case "png"
                                'Save Diagram to created image.
                                imgDiagram = Me.ActiveDiagram.ExportDiagramAsImage(False)
                                ' Save image as metafile.
                                imgDiagram.Save(strFileName, ImageFormat.Png)
                            Case "jpg"
                            Case "jpeg"
                                'Save Diagram to created image.
                                imgDiagram = Me.ActiveDiagram.ExportDiagramAsImage(False)
                                ' Save image as metafile.
                                imgDiagram.Save(strFileName, ImageFormat.Jpeg)
                            Case "tiff"
                                'Save Diagram to created image.
                                imgDiagram = Me.ActiveDiagram.ExportDiagramAsImage(False)
                                ' Save image as metafile.
                                imgDiagram.Save(strFileName, ImageFormat.Tiff)
       							 case "gif":
                                'Save Diagram to created image.
                                imgDiagram = Me.ActiveDiagram.ExportDiagramAsImage(False)
                                ' Save image as metafile.
                                imgDiagram.Save(strFileName, ImageFormat.Gif)
                            Case "bmp"
                                'Save Diagram to created image.
                                imgDiagram = Me.ActiveDiagram.ExportDiagramAsImage(False)
                                ' Save image as metafile.
                                imgDiagram.Save(strFileName, ImageFormat.Bmp)
                            Case Else
                                docForm.SaveAsFile(Me.saveDiagramDialog.FileName)
                        End Select
                    End If
                End If
            End If
        End Sub

        Private Sub biPrintPreview_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles biPrintPreview.Click
            Me.PrintPreview()
        End Sub

        Private Sub biFilePrint_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles biFilePrint.Click
            Me.Print()
        End Sub

        Private Sub biPageSetup_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles biPageSetup.Click
            Me.PageSetup()
        End Sub

        Private Sub biFileExit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles biFileExit.Click
            Application.Exit()
        End Sub


        Private Sub barItemHeaderFooter_Click(ByVal sender As Object, ByVal e As EventArgs) Handles barItemHeaderFooter.Click
            HeaderFooterSetup()
        End Sub

        Private Sub barItemPageBorders_Click(ByVal sender As Object, ByVal e As EventArgs) Handles barItemPageBorders.Click
            PageBordersSetup()
        End Sub


#End Region

		#Region "Edit Menu Event Handlers"

		Private Sub barItemEditCut_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemEditCut.Click
			If Not Me.ActiveMdiChild Is Nothing Then
				Dim diagramForm As DiagramForm = CType(IIf(TypeOf Me.ActiveMdiChild Is DiagramForm, Me.ActiveMdiChild, Nothing), DiagramForm)
				If Not diagramForm Is Nothing Then
					diagramForm.Diagram.Controller.Cut()
				End If
			End If
		End Sub

		Private Sub barItemEditCopy_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemEditCopy.Click
			If Not Me.ActiveMdiChild Is Nothing Then
				Dim diagramForm As DiagramForm = CType(IIf(TypeOf Me.ActiveMdiChild Is DiagramForm, Me.ActiveMdiChild, Nothing), DiagramForm)
				If Not diagramForm Is Nothing Then
					diagramForm.Diagram.Controller.Copy()
				End If
			End If
		End Sub

		Private Sub barItemEditPaste_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemEditPaste.Click
			If Not Me.ActiveMdiChild Is Nothing Then
				Dim diagramForm As DiagramForm = CType(IIf(TypeOf Me.ActiveMdiChild Is DiagramForm, Me.ActiveMdiChild, Nothing), DiagramForm)
				If Not diagramForm Is Nothing Then
					diagramForm.Diagram.Controller.Paste()
				End If
			End If
		End Sub

		Private Sub barItemEditUndo_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemEditUndo.Click
			If Not Me.ActiveMdiChild Is Nothing Then
				Dim diagramForm As DiagramForm = CType(IIf(TypeOf Me.ActiveMdiChild Is DiagramForm, Me.ActiveMdiChild, Nothing), DiagramForm)
				If Not diagramForm Is Nothing Then
					diagramForm.Diagram.Controller.UndoCommand()
				End If
			End If
		End Sub

		Private Sub barItemEditRedo_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemEditRedo.Click
			If Not Me.ActiveMdiChild Is Nothing Then
				Dim diagramForm As DiagramForm = CType(IIf(TypeOf Me.ActiveMdiChild Is DiagramForm, Me.ActiveMdiChild, Nothing), DiagramForm)
				If Not diagramForm Is Nothing Then
					diagramForm.Diagram.Controller.RedoCommand()
				End If
			End If
		End Sub

		Private Sub barItemEditSelectAll_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemEditSelectAll.Click
			If Not Me.ActiveMdiChild Is Nothing Then
				Dim diagramForm As DiagramForm = CType(IIf(TypeOf Me.ActiveMdiChild Is DiagramForm, Me.ActiveMdiChild, Nothing), DiagramForm)
				If Not diagramForm Is Nothing Then
					diagramForm.Diagram.Controller.SelectAll()
				End If
			End If
		End Sub

		Private Sub barItemDelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemDelete.Click
			If Not Me.ActiveMdiChild Is Nothing Then
				Dim diagramForm As DiagramForm = CType(IIf(TypeOf Me.ActiveMdiChild Is DiagramForm, Me.ActiveMdiChild, Nothing), DiagramForm)
				If Not diagramForm Is Nothing Then
					diagramForm.Diagram.Controller.Delete()
				End If
			End If
		End Sub

		#End Region

		#Region "View Menu Event Handlers"

		Private Sub barItemViewSymbolPalette_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemViewSymbolPalette.Click
			If Me.barItemViewSymbolPalette.Checked Then
				Me.dockingManager.SetDockVisibility(Me.symbolPaletteGroupBar, False)
				Me.barItemViewSymbolPalette.Checked = False
			Else
				Me.dockingManager.SetDockVisibility(Me.symbolPaletteGroupBar, True)
				Me.barItemViewSymbolPalette.Checked = True
			End If
		End Sub

		Private Sub barItemViewProperties_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemViewProperties.Click
			If Me.barItemViewProperties.Checked Then
				Me.dockingManager.SetDockVisibility(Me.propertyEditor_Renamed, False)
				Me.barItemViewProperties.Checked = False
			Else
				Me.dockingManager.SetDockVisibility(Me.propertyEditor_Renamed, True)
				Me.barItemViewProperties.Checked = True
			End If
		End Sub

		Private Sub barItemPanZoom_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemPanZoom.Click
			If Me.barItemPanZoom.Checked = True Then
				' Hide the overview control
				Me.dockingManager.SetDockVisibility(Me.overviewControl1, False)
				Me.barItemPanZoom.Checked = False
			Else
				' Initialize the OverviewControl with the active diagram's Model & View and display the control
				If (Not Me.ActiveDiagram Is Nothing) AndAlso (Me.dockingManager.GetDockVisibility(Me.overviewControl1) = False) Then
					Me.dockingManager.SetDockVisibility(Me.overviewControl1, True)
					Me.overviewControl1.Model = Me.ActiveDiagram.Model
					Me.overviewControl1.View = Me.ActiveDiagram.View
				End If
				Me.barItemPanZoom.Checked = True
			End If
		End Sub

		Private Sub HeaderFooterSetup()
            Dim activeDiagram As Controls.Diagram = Me.ActiveDiagram
            If Not activeDiagram Is Nothing AndAlso Not activeDiagram.Model Is Nothing Then
                Dim dlgHF As HeaderFooterDialog = New HeaderFooterDialog
                dlgHF.Header = activeDiagram.Model.HeaderFooterData.Header
                dlgHF.Footer = activeDiagram.Model.HeaderFooterData.Footer
                dlgHF.MeasurementUnits = activeDiagram.Model.MeasurementUnits
                If dlgHF.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                    activeDiagram.Model.HeaderFooterData.Header = dlgHF.Header
                    activeDiagram.Model.HeaderFooterData.Footer = dlgHF.Footer
                End If
            End If
        End Sub

        Private Sub PageBordersSetup()
            Dim activeDgm As Controls.Diagram = Me.ActiveDiagram
            If Not activeDgm Is Nothing AndAlso Not activeDgm.View Is Nothing Then
                Dim dlgPageBorders As PageBorderDialog = New PageBorderDialog
                dlgPageBorders.PageBorderStyle = activeDgm.View.PageBorderStyle
                If dlgPageBorders.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                    activeDgm.View.PageBorderStyle = dlgPageBorders.PageBorderStyle
                End If
            End If
        End Sub


#End Region

		#Region "Window Menu Event Handlers"

		Private Sub biTabbedMDI_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles biTabbedMDI.Click
			' Toggle tabbed MDI mode
			Dim barItem As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem = CType(IIf(TypeOf sender Is Syncfusion.Windows.Forms.Tools.XPMenus.BarItem, sender, Nothing), Syncfusion.Windows.Forms.Tools.XPMenus.BarItem)
			If Not barItem Is Nothing Then
				If barItem.Checked Then
					tabbedMDIManager.DetachFromMdiContainer(Me, True)
					barItem.Checked = False
				Else
					tabbedMDIManager.AttachToMdiContainer(Me)
					barItem.Checked = True
				End If
			End If
		End Sub

		#End Region

		#Region "Help Menu Event Handlers"

		Private Sub barItemAbout_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItemAbout.Click
			Dim aboutDlg As About = New About()
			aboutDlg.ShowDialog(Me)
		End Sub

		#End Region

		#Region "Docking"

		Private Sub dockingManager_DockVisibilityChanged(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Tools.DockVisibilityChangedEventArgs) Handles dockingManager.DockVisibilityChanged
			If e.Control Is Me.propertyEditor_Renamed Then
				Me.barItemViewProperties.Checked = Me.dockingManager.GetDockVisibility(Me.propertyEditor_Renamed)
			Else If e.Control Is Me.symbolPaletteGroupBar Then
				Me.barItemViewSymbolPalette.Checked = Me.dockingManager.GetDockVisibility(Me.symbolPaletteGroupBar)
			Else If e.Control Is Me.overviewControl1 Then
				Me.barItemPanZoom.Checked = Me.dockingManager.GetDockVisibility(Me.overviewControl1)
			End If
		End Sub

		#End Region

		#Region "UI Updating"

		Private Sub OnIdle(ByVal sender As Object, ByVal evtArgs As System.EventArgs)
'INSTANT VB NOTE: The local variable activeDiagram was renamed since Visual Basic will not uniquely identify class members when local variables have the same name:
            Dim activeDiagram As Syncfusion.Windows.Forms.Diagram.Controls.Diagram = Me.ActiveDiagram

			Dim editUndoText As String = Me.resStringMgr.GetString("EditUndoText")
			Dim editRedoText As String = Me.resStringMgr.GetString("EditRedoText")

            If Not activeDiagram Is Nothing Then
                Me.biFileSave.Enabled = True
                Me.biFileSaveAs.Enabled = True
                Me.barItemEditCopy.Enabled = activeDiagram.CanCopy
                Me.barItemEditCut.Enabled = activeDiagram.CanCut
                Me.barItemEditPaste.Enabled = activeDiagram.CanPaste
                Me.barItemEditUndo.Enabled = activeDiagram.Controller.CanUndo()
                Me.barItemEditRedo.Enabled = activeDiagram.Controller.CanRedo
                Me.barItemEditUndo.Enabled = True
                Me.barItemEditRedo.Enabled = True
                Me.barItemEditSelectAll.Enabled = True
                Me.biFilePrint.Enabled = True
                Me.biPageSetup.Enabled = True

                Dim strDescriptions As String()
                Dim nDescWanted As Integer = 1
                Dim nDescReturned As Integer = activeDiagram.Controller.GetUndoDescriptions(nDescWanted, strDescriptions)

                If nDescReturned = nDescWanted Then
                    editUndoText = editUndoText & " " & strDescriptions(0)
                End If

                ' clear strDecsriptions.
                strDescriptions = Nothing
                nDescReturned = activeDiagram.Controller.GetRedoDescriptions(nDescWanted, strDescriptions)
                If nDescReturned = nDescWanted Then
                    editRedoText = editRedoText & " " & strDescriptions(0)
                End If
            Else
                Me.biFileSave.Enabled = False
                Me.biFileSaveAs.Enabled = False
                Me.barItemEditCopy.Enabled = False
                Me.barItemEditCut.Enabled = False
                Me.barItemEditPaste.Enabled = False
                Me.barItemEditUndo.Enabled = False
                Me.barItemEditRedo.Enabled = False
                Me.barItemEditSelectAll.Enabled = False
                Me.biFilePrint.Enabled = False
                Me.biPageSetup.Enabled = False
            End If

            Me.barItemEditUndo.Text = editUndoText
            Me.barItemEditRedo.Text = editRedoText
		End Sub

		#End Region

		#Region "Printing"

		Private Sub PageSetup()
'INSTANT VB NOTE: The local variable activeDiagram was renamed since Visual Basic will not uniquely identify class members when local variables have the same name:
            Dim activeDiagram As Syncfusion.Windows.Forms.Diagram.Controls.Diagram = Me.ActiveDiagram

            If Not activeDiagram Is Nothing AndAlso Not activeDiagram.Model Is Nothing Then
                Dim dlgPrintSetup As Syncfusion.Windows.Forms.Diagram.PrintSetupDialog = New PrintSetupDialog

                ' Made to make values more user friendly 
                dlgPrintSetup.PageSettings = activeDiagram.View.PageSettings
                dlgPrintSetup.PrintZoom = activeDiagram.View.PrintZoom

                If dlgPrintSetup.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                    activeDiagram.View.PageSettings = dlgPrintSetup.PageSettings
                    activeDiagram.View.PrintZoom = dlgPrintSetup.PrintZoom
                    activeDiagram.View.RefreshPageSettings()
                    activeDiagram.View.Update(True)
                End If
            End If
		End Sub

		Private Sub Print()
'INSTANT VB NOTE: The local variable activeDiagram was renamed since Visual Basic will not uniquely identify class members when local variables have the same name:
            Dim activeDiagram As Syncfusion.Windows.Forms.Diagram.Controls.Diagram = Me.ActiveDiagram
            If Not activeDiagram Is Nothing Then
                Dim printDoc As System.Drawing.Printing.PrintDocument = activeDiagram.CreatePrintDocument()
                Dim printDlg As PrintDialog = New PrintDialog
                printDlg.Document = printDoc

                printDlg.AllowSomePages = True

                If printDlg.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK Then
                    printDoc.PrinterSettings = printDlg.PrinterSettings
                    printDoc.Print()
                End If
            End If
		End Sub

		Private Sub PrintPreview()
'INSTANT VB NOTE: The local variable activeDiagram was renamed since Visual Basic will not uniquely identify class members when local variables have the same name:
            Dim activeDiagram As Syncfusion.Windows.Forms.Diagram.Controls.Diagram = Me.ActiveDiagram

            If Not activeDiagram Is Nothing Then
                Dim printDoc As System.Drawing.Printing.PrintDocument = activeDiagram.CreatePrintDocument()
                Dim printPreviewDlg As PrintPreviewDialog = New PrintPreviewDialog

                printDoc.PrinterSettings.FromPage = 0
                printDoc.PrinterSettings.ToPage = 0
                printDoc.PrinterSettings.PrintRange = PrintRange.AllPages

                printPreviewDlg.Document = printDoc
                printPreviewDlg.ShowDialog(Me)
            End If
		End Sub

		#End Region

		#Region "MDI Window Management"

		Private Sub DiagramForm_Closing(ByVal sender As Object, ByVal e As CancelEventArgs)
			Dim docForm As DiagramForm = CType(IIf(TypeOf sender Is DiagramForm, sender, Nothing), DiagramForm)
			If Not docForm Is Nothing Then
				If docForm.Diagram.Model.Modified Then
					Dim res As DialogResult = MessageBox.Show(Me, "The diagram has been modified. Save changes?", "Save changes", MessageBoxButtons.YesNoCancel)
                    If res = System.Windows.Forms.DialogResult.Yes Then
                        If docForm.HasFileName Then
                            Me.saveDiagramDialog.FileName = docForm.FileName
                        End If
                        If Me.saveDiagramDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK Then
                            docForm.SaveAsFile(Me.saveDiagramDialog.FileName)
                        Else
                            e.Cancel = True
                        End If
                    ElseIf res = System.Windows.Forms.DialogResult.Cancel Then
                        e.Cancel = True
                    End If
				End If
			End If
		End Sub

		#End Region

#Region "Helper Methods"

#End Region
        ''' <summary>
        ''' The main entry point for the application.
        ''' </summary>
        <STAThread()> _
        Shared Sub Main()
            ' Register scripting engines
            ScriptEngineFactory.RegisterScriptEngine(ScriptLanguages.VisualBasic, GetType(Microsoft.VisualBasic.Vsa.VsaEngine))
            ScriptEngineFactory.RegisterScriptEngine(ScriptLanguages.JScript, GetType(Microsoft.JScript.Vsa.VsaEngine))

            AddHandler Application.ThreadException, AddressOf Syncfusion.Windows.Forms.Diagram.DefaultExceptionHandler.Singleton.OnThreadException
            Application.Run(New MainForm())
            RemoveHandler Application.ThreadException, AddressOf Syncfusion.Windows.Forms.Diagram.DefaultExceptionHandler.Singleton.OnThreadException
        End Sub
    End Class
End Namespace
